﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.1.3 - config
-- Author : Meranannon - Discordia - Vol'jin (EU)
-- rev 5
----------------------------------------------------------------------------------------------------

DFREFS={}

DF_namespace.anchor={}

DF_namespace.practiceNotRunning=true
DF_namespace.practiceCheckBuff=true
DF_namespace.practiceCheckDebuff=true
DF_namespace.practiceCheckAura=false

DF_namespace.lock=true
DF_namespace.configmode=false
DF_namespace.currentTime=GetTime()
DF_namespace.playerId = nil
DF_namespace.playerClass = nil
DF_namespace.playerLevel = nil
DF_namespace.playerTalent = nil
DF_namespace.playerTalentName = nil
DF_namespace.playerpoint = nil
DF_namespace.myArgs = ""
DF_namespace.menace = 0
DF_namespace.position3d = nil

DF_namespace.configToLoad = nil
DF_namespace.AnimaticToLoad = nil
DF_namespace.haveTarget=nil

DF_namespace.wipespell = true

DF_namespace.environnement = getfenv(0)

DF_namespace.DefaultSpell={
	spellIDs="0",
	abiUserText="",
	positionx=64,
	positiony=64,
	width=32,
	height=32,
	sType="DebuffTarget",
	showcd=true,
	showdottimer=true,
	perso=true,
	combo=false,
	icon=1,
	abiInternalCD=0,
	timerbar=0,
	color={r=1,v=0,b=0,a=1},
	abiSound="",
	form={true,true,true,true,true,true,true,true},
	strongcheck=false,
	FX_enable=false,
	FX_stack=0,
	FX_name="Custom",
	FX_width=128,
	FX_height=128,
	FX_texture="Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
	FX_customtexture="",
	FX_mode="BLEND",
	FX_angle=0,
	FX_start_posx=0,
	FX_middle_posx=0,
	FX_end_posx=0,
	FX_start_posy=0,
	FX_middle_posy=0,
	FX_end_posy=0,
	FX_start_alpha=0,
	FX_middle_alpha=1,
	FX_end_alpha=0,
	FX_start_scale=0.5,
	FX_middle_scale=1,
	FX_end_scale=0.5,
	FX_start_width=1,
	FX_middle_width=1,
	FX_end_width=1,		
	FX_start_height=1,
	FX_middle_height=1,
	FX_end_height=1,
	FX_speed=40,
	FX_rotatespeed=0,
	FX_chakerpower=0,
	FX_pulsepowerX=0,
	FX_pulsespeedX=0,
	FX_pulsepowerY=0,
	FX_pulsespeedY=0,
	FX_pulsepowerZ=0,
	FX_pulsespeedZ=0,
	FX_timerenable=false,			
	FX_timerposx=0,
	FX_timerposy=0,
	FX_timersmall=true,
	FX_timerabove=false,
	FX_timerscale=0.40,
	FX_timeralpha=0.35,
	FX_textenabled=false,
	FX_fontPath="Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
	FX_textsize=12,
	FX_textColor={
		["a"] = 0.5,
		["r"] = 1,
		["v"] = 1,
		["b"] = 1,		
	},
	FX_textalign="CENTER",
	FX_textoffsetx=0,
	FX_textoffsety=-40,
	luaCode="",
	comboPoints=0,
}

StaticPopupDialogs["WIPESPELLS"] = {
  text = DF_namespace.locale["loadconfigansw"],
  button1 = DF_namespace.locale["loadconfigkeep"],
  button2 = DF_namespace.locale["loadconfigdisc"],
	OnAccept = function()
		DF_namespace:config_Loadok(DF_namespace.configToLoad,false,false)
	end,
	OnCancel = function()
		DF_namespace:config_Loadok(DF_namespace.configToLoad,false,true)
	end,  
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
};

-- effacement valeur d'une table
function DF_namespace:clearTable(source,spellstoo)
	local function _clear(csource)
		for index, value in pairs(csource) do
			if type(csource[index]) ~= "table" then
				csource[index]=nil
			else
				if (tostring(index)~="spells" or (tostring(index)=="spells" and spellstoo==true)) then
					_clear(csource[index])
				end
			end
		end
	end
	_clear(source)
end

-- copy d'une table vers une autre
function DF_namespace:copyTable(source,destination,spellstoo)
	local function _copy(csource,cdestination)
		for index, value in pairs(csource) do
			if type(csource[index]) ~= "table" then
				cdestination[index]=csource[index]
			else
				if (tostring(index)~="spells" or (tostring(index)=="spells" and spellstoo==true)) then
					if cdestination[index]==nil or not cdestination[index] then
						cdestination[index]={}
					end
					_copy(csource[index],cdestination[index])
				end
			end
		end
	end
	
	_copy(source,destination)
	
end

function DF_namespace:deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

	-- Compléte la configuration actuel avec les variables de la config par default
function DF_namespace:completeTable(tcurrent,tdefaut,force)
	local chemin="config"
	local function _check(current,defaut,chemin,force)
		--DF_namespace:debugLine("chemin ",chemin)
		for index, value in pairs(defaut) do
			if type(defaut[index]) ~= "table" then
				if current[index]==nil then
					current[index]=defaut[index]
					--DF_namespace:debugLine("SET "..tostring(index),defaut[index])
				end
			else
				if chemin~="config.spells" or force then
					if current[index]==nil or not current[index] then
						current[index]={}
						--DF_namespace:debugLine("INDEX "..tostring(index),true)
					end				
					_check(current[index],defaut[index],chemin.."."..tostring(index),force)
				end
			end
		end
	end
	_check(tcurrent,tdefaut,chemin,force)	
end

function DF_namespace:configSaved(name)
	local nbConf=getn(DF_saved_configs)
	for i = 1,nbConf do
		if DF_saved_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DF_namespace:configBuildin(name)
	local nbConf=getn(DF_pred_configs)
	for i = 1,nbConf do
		if DF_pred_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DF_namespace:config_Save(name)
	
	if not name then name=DF_config.configname end
	
	name=name:gsub("BuildIn", "User")
	DF_config.configname=name
	DF_config.configversion=DROODFOCUS_CONFIGVERSION
	conf = DF_namespace:configSaved(name)

	if conf==0 then
		conf=getn(DF_saved_configs)+1
		DF_saved_configs[conf] = {}
	end

	DF_config.configversion=DROODFOCUS_CONFIGVERSION

	DF_saved_configs[conf] = DF_namespace:deepcopy(DF_config)
	DF_saved_configs[conf].configname=name

	DF_namespace:options_SavedconfigLists()
	
	DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["saved"]..name)
	
end

function DF_namespace:config_Load(name,showconfig)

	if not name then name=DF_namespace.configToLoad end
	DF_namespace.configToLoad=name;
	
	StaticPopup_Show("WIPESPELLS");

end

function DF_namespace:config_Loadok(name,showconfig,wipespell)

	DF_namespace:hide_ooc_frame()
	
	if not name then name=DF_namespace.configToLoad end
	
	if string.find(name, "BuildIn") then
		conf = DF_namespace:configBuildin(name)
		if conf~=0 then
			
			if (wipespell==true) then
				while getn(DF_config.spells)>getn(DF_pred_configs[conf].spells) do
					table.remove(DF_config.spells,getn(DF_config.spells))
				end
			end
			
			DF_namespace:options_hide()
			DF_namespace:clearTable(DF_config,wipespell)
			DF_namespace:copyTable(DF_pred_configs[conf],DF_config,wipespell)
			DF_namespace:completeTable(DF_config,DF_pred_configs[1],false)
			DF_namespace:updateTable()
			
			DF_namespace:init_frames()
			DF_namespace:toggle_toggle()
			DF_MinimapToggle()
			DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["loaded"]..DF_config.configname)
			
			if (showconfig==true) then
				DF_namespace:options_hide("DFOPTIONSelement");
				DF_namespace:options_show("DFOPTIONSelement")
			end
			
			DF_namespace.environnement["confignamebox"]:Hide()
			DF_namespace.environnement["confignamebox"]:Show()		
			DF_config.configversion=DROODFOCUS_CONFIGVERSION
			return
		end
	else
		conf = DF_namespace:configSaved(name)
		if conf~=0 then

			if (wipespell==true) then
				while getn(DF_config.spells)>getn(DF_saved_configs[conf].spells) do
					table.remove(DF_config.spells,getn(DF_config.spells))
				end
			end
			
			DF_namespace:options_hide()
			
			DF_namespace:clearTable(DF_config,wipespell)
			DF_namespace:copyTable(DF_saved_configs[conf],DF_config,wipespell)
			DF_namespace:completeTable(DF_config,DF_pred_configs[1],false)
			DF_namespace:updateTable()
			
			DF_namespace:init_frames()
			DF_namespace:toggle_toggle()
			DF_MinimapToggle()
			DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["loaded"]..DF_config.configname)
			
			if (showconfig==true) then
				DF_namespace:options_hide("DFOPTIONSelement");
				DF_namespace:options_show("DFOPTIONSelement")
			end
			
			DF_namespace.environnement["confignamebox"]:Hide()
			DF_namespace.environnement["confignamebox"]:Show()		
			DF_config.configversion=DROODFOCUS_CONFIGVERSION
			return
		end
	end
	
end

function DF_namespace:config_Reset()

	DF_namespace:hide_ooc_frame()

	while getn(DF_config.spells)>getn(DF_pred_configs[1].spells) do
		table.remove(DF_config.spells,getn(DF_config.spells))
	end

	DF_namespace:options_hide()
	
	DF_namespace:clearTable(DF_config,true)
	DF_namespace:copyTable(DF_pred_configs[1],DF_config,true)
	DF_namespace:completeTable(DF_config,DF_pred_configs[1],false)
	DF_namespace:updateTable()
	
	DF_namespace:init_frames()
	DF_namespace:toggle_toggle()
	DF_namespace.environnement["confignamebox"]:Hide()
	DF_namespace.environnement["confignamebox"]:Show()
	DF_namespace.environnement["dfcombat"]:Hide()
	DF_namespace.environnement["dfcombat"]:Show()
	DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["reset"])
	DF_config.configversion=DROODFOCUS_CONFIGVERSION
end

function DF_namespace:updateTable()

	-- mise a jour des positions des ancres par rapport a l'ancre global
	-- (pas de changement sur les version supérieure a la 4.1.5)
	if tonumber(DF_config.configversion)<415 then

		-- position de l'ancre 1
		tempx=DF_config["anchor1"].positionx
		tempy=DF_config["anchor1"].positiony	

		-- initialisation de l'ancre 0 a coté de l'ancre 1
		DF_config["anchor0"].positionx = tempx-32
		DF_config["anchor0"].positiony = tempy+32
		globalx=DF_config["anchor0"].positionx
		globaly=DF_config["anchor0"].positiony
		
		nbAnchors = 7
		-- replacement des ancre 1 a 7 par rapport a l'ancre 0		
		for i = 1,nbAnchors do
			
			tempx=DF_config["anchor"..tostring(i)].positionx
			tempy=DF_config["anchor"..tostring(i)].positiony
			
			if (tempx==0 and tempy==0) then
				DF_config["anchor"..tostring(i)].positionx = -200
				DF_config["anchor"..tostring(i)].positiony = 0
			else
				DF_config["anchor"..tostring(i)].positionx = (tempx-globalx)
				DF_config["anchor"..tostring(i)].positiony = (tempy-globaly)
			end
			
		end

		DF_config["anchor0"].positionx = ( GetScreenWidth() * UIParent:GetEffectiveScale() )/2
		DF_config["anchor0"].positiony = ( GetScreenHeight() * UIParent:GetEffectiveScale() )/2

	end
	
	if tonumber(DF_config.configversion)<419 then
		
		-- ajout auto de l'effet special OOC
		if DF_config.ooc.enable then

			table.insert(DF_config.spells, 1, {})
			DF_namespace:copyTable(DF_namespace.DefaultSpell,DF_config.spells[1],true)
			
			DF_config.spells[1].spellIDs="16870"
			DF_config.spells[1].sType="BuffPlayer"
			DF_config.spells[1].icon=0
			DF_config.spells[1].timerbar=0
			
			DF_config.spells[1].FX_enable=true
			DF_config.spells[1].FX_positionx=DF_config.ooc.positionx
			DF_config.spells[1].FX_positiony=DF_config.ooc.positiony
			DF_config.spells[1].FX_width=DF_config.ooc.width
			DF_config.spells[1].FX_height=DF_config.ooc.height
			DF_config.spells[1].FX_level=DF_config.ooc.level
			DF_config.spells[1].FX_mode=DF_config.ooc.mode
			DF_config.spells[1].FX_texture="Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga"

			DF_config.spells[1].FX_start_scale=2.5
			DF_config.spells[1].FX_middle_scale=1.25
			DF_config.spells[1].FX_end_scale=2.5

			DF_config.spells[1].FX_start_posx=0
			DF_config.spells[1].FX_middle_posx=0
			DF_config.spells[1].FX_end_posx=0
			
			DF_config.spells[1].FX_start_posy=0
			DF_config.spells[1].FX_middle_posy=0
			DF_config.spells[1].FX_end_posy=0	

			DF_config.spells[1].FX_start_alpha=0
			DF_config.spells[1].FX_middle_alpha=1
			DF_config.spells[1].FX_end_alpha=0

			DF_config.spells[1].FX_speed=40

			DF_config.spells[1].FX_rotatespeed=0.5
			DF_config.spells[1].FX_chakerpower=1
			
		end
		
	end

	if tonumber(DF_config.configversion)<427 then

		DF_config.timerbars[1].width=DF_config.timerbar.width
		DF_config.timerbars[1].height=DF_config.timerbar.height
		DF_config.timerbars[1].texturePath=DF_config.timerbar.texturePath
		DF_config.timerbars[1].font1Path=DF_config.timerbar.font1Path
		DF_config.timerbars[1].font1Size=DF_config.timerbar.font1Size
		DF_config.timerbars[1].font2Path=DF_config.timerbar.font2Path
		DF_config.timerbars[1].font2Size=DF_config.timerbar.font2Size
		DF_config.timerbars[1].activeAlpha=DF_config.timerbar.activeAlpha
		DF_config.timerbars[1].inactiveAlpha=DF_config.timerbar.inactiveAlpha
		DF_config.timerbars[1].border=DF_config.timerbar.border
		DF_config.timerbars[1].borderSize=DF_config.timerbar.borderSize
		DF_config.timerbars[1].timeline=DF_config.timerbar.timeline
		DF_config.timerbars[1].prop=DF_config.timerbar.prop
		DF_config.timerbars[1].orderByTime=DF_config.timerbar.orderByTime
		DF_config.timerbars[1].level=DF_config.timerbar.level
		DF_config.timerbars[1].growup=DF_config.timerbar.growup
		DF_config.timerbars[1].stackup1=DF_config.timerbar.stackup1
		DF_config.timerbars[1].showSpark=DF_config.timerbar.showSpark
		DF_config.timerbars[1].activeAlphaCD=DF_config.timerbar.activeAlphaCD
		DF_config.timerbars[1].cdoffsety=DF_config.timerbar.cdoffsety
		DF_config.timerbars[1].textColor.a=DF_config.timerbar.textColor.a
		DF_config.timerbars[1].textColor.r=DF_config.timerbar.textColor.r
		DF_config.timerbars[1].textColor.v=DF_config.timerbar.textColor.v
		DF_config.timerbars[1].textColor.b=DF_config.timerbar.textColor.b
		DF_config.timerbars[1].borderColor.a=DF_config.timerbar.borderColor.a
		DF_config.timerbars[1].borderColor.r=DF_config.timerbar.borderColor.r
		DF_config.timerbars[1].borderColor.v=DF_config.timerbar.borderColor.v
		DF_config.timerbars[1].borderColor.b=DF_config.timerbar.borderColor.b
		DF_config.timerbars[1].cdColor.a=DF_config.timerbar.cdColor.a
		DF_config.timerbars[1].cdColor.r=DF_config.timerbar.cdColor.r
		DF_config.timerbars[1].cdColor.v=DF_config.timerbar.cdColor.v
		DF_config.timerbars[1].cdColor.b=DF_config.timerbar.cdColor.b
		DF_config.timerbars[1].textsoffsets[1].offsetx=DF_config.timerbar.textsoffsets[1].offsetx
		DF_config.timerbars[1].textsoffsets[1].offsety=DF_config.timerbar.textsoffsets[1].offsety
		DF_config.timerbars[1].textsoffsets[2].offsetx=DF_config.timerbar.textsoffsets[2].offsetx
		DF_config.timerbars[1].textsoffsets[2].offsety=DF_config.timerbar.textsoffsets[2].offsety

		DF_config.timerbars[2].width=DF_config.timerbar.width2
		DF_config.timerbars[2].height=DF_config.timerbar.height2
		DF_config.timerbars[2].texturePath=DF_config.timerbar.texturePath
		DF_config.timerbars[2].font1Path=DF_config.timerbar.font1Path
		DF_config.timerbars[2].font1Size=DF_config.timerbar.font1Size
		DF_config.timerbars[2].font2Path=DF_config.timerbar.font2Path
		DF_config.timerbars[2].font2Size=DF_config.timerbar.font2Size
		DF_config.timerbars[2].activeAlpha=DF_config.timerbar.activeAlpha2
		DF_config.timerbars[2].inactiveAlpha=DF_config.timerbar.inactiveAlpha2
		DF_config.timerbars[2].border=DF_config.timerbar.border
		DF_config.timerbars[2].borderSize=DF_config.timerbar.borderSize
		DF_config.timerbars[2].timeline=DF_config.timerbar.timeline
		DF_config.timerbars[2].prop=DF_config.timerbar.prop2
		DF_config.timerbars[2].orderByTime=DF_config.timerbar.orderByTime
		DF_config.timerbars[2].level=DF_config.timerbar.level
		DF_config.timerbars[2].growup=DF_config.timerbar.growup
		DF_config.timerbars[2].stackup1=DF_config.timerbar.stackup2
		DF_config.timerbars[2].showSpark=DF_config.timerbar.showSpark
		DF_config.timerbars[2].activeAlphaCD=DF_config.timerbar.activeAlphaCD2
		DF_config.timerbars[2].cdoffsety=DF_config.timerbar.cdoffsety
		DF_config.timerbars[2].textColor.a=DF_config.timerbar.textColor.a
		DF_config.timerbars[2].textColor.r=DF_config.timerbar.textColor.r
		DF_config.timerbars[2].textColor.v=DF_config.timerbar.textColor.v
		DF_config.timerbars[2].textColor.b=DF_config.timerbar.textColor.b
		DF_config.timerbars[2].borderColor.a=DF_config.timerbar.borderColor.a
		DF_config.timerbars[2].borderColor.r=DF_config.timerbar.borderColor.r
		DF_config.timerbars[2].borderColor.v=DF_config.timerbar.borderColor.v
		DF_config.timerbars[2].borderColor.b=DF_config.timerbar.borderColor.b
		DF_config.timerbars[2].cdColor.a=DF_config.timerbar.cdColor.a
		DF_config.timerbars[2].cdColor.r=DF_config.timerbar.cdColor.r
		DF_config.timerbars[2].cdColor.v=DF_config.timerbar.cdColor.v
		DF_config.timerbars[2].cdColor.b=DF_config.timerbar.cdColor.b
		DF_config.timerbars[2].textsoffsets[1].offsetx=DF_config.timerbar.textsoffsets[1].offsetx
		DF_config.timerbars[2].textsoffsets[1].offsety=DF_config.timerbar.textsoffsets[1].offsety
		DF_config.timerbars[2].textsoffsets[2].offsetx=DF_config.timerbar.textsoffsets[2].offsetx
		DF_config.timerbars[2].textsoffsets[2].offsety=DF_config.timerbar.textsoffsets[2].offsety

		DF_config.iconbars[1].fontSize=DF_config.icons.fontSize
		DF_config.iconbars[1].orderByTime=DF_config.icons.orderByTime
		DF_config.iconbars[1].decimal=DF_config.icons.decimal
		DF_config.iconbars[1].automatic=DF_config.icons.automatic
		DF_config.iconbars[1].showSpiral=DF_config.icons.showSpiral
		DF_config.iconbars[1].inactiveAlpha=DF_config.icons.inactiveAlpha
		DF_config.iconbars[1].level=DF_config.icons.level
		DF_config.iconbars[1].textsoffsets[1].visible=DF_config.icons.textsoffsets[1].visible
		DF_config.iconbars[1].textsoffsets[1].offsety=DF_config.icons.textsoffsets[1].offsety
		DF_config.iconbars[1].textsoffsets[1].align=DF_config.icons.textsoffsets[1].align
		DF_config.iconbars[1].textsoffsets[1].offsetx=DF_config.icons.textsoffsets[1].offsetx
		DF_config.iconbars[1].textsoffsets[1].size=DF_config.icons.textsoffsets[1].size
		DF_config.iconbars[1].textsoffsets[2].visible=DF_config.icons.textsoffsets[2].visible
		DF_config.iconbars[1].textsoffsets[2].offsety=DF_config.icons.textsoffsets[2].offsety
		DF_config.iconbars[1].textsoffsets[2].align=DF_config.icons.textsoffsets[2].align
		DF_config.iconbars[1].textsoffsets[2].offsetx=DF_config.icons.textsoffsets[2].offsetx
		DF_config.iconbars[1].textsoffsets[2].size=DF_config.icons.textsoffsets[2].size
		DF_config.iconbars[1].textsoffsets[3].visible=DF_config.icons.textsoffsets[3].visible
		DF_config.iconbars[1].textsoffsets[3].offsety=DF_config.icons.textsoffsets[3].offsety
		DF_config.iconbars[1].textsoffsets[3].align=DF_config.icons.textsoffsets[3].align
		DF_config.iconbars[1].textsoffsets[3].offsetx=DF_config.icons.textsoffsets[3].offsetx
		DF_config.iconbars[1].textsoffsets[3].size=DF_config.icons.textsoffsets[3].size
		DF_config.iconbars[1].colonne=DF_config.icons.colonne
		DF_config.iconbars[1].fontPath=DF_config.icons.fontPath
		DF_config.iconbars[1].mode=DF_config.icons.mode
		DF_config.iconbars[1].pointpa=DF_config.icons.pointpa
		DF_config.iconbars[1].width=DF_config.icons.width
		DF_config.iconbars[1].height=DF_config.icons.height
		DF_config.iconbars[1].speed=DF_config.icons.speed
		DF_config.iconbars[1].pulse=DF_config.icons.pulse
		DF_config.iconbars[1].activeAlpha=DF_config.icons.activeAlpha
		DF_config.iconbars[1].growup=DF_config.icons.growup
		DF_config.iconbars[1].textColor.a=DF_config.icons.textColor.a
		DF_config.iconbars[1].textColor.r=DF_config.icons.textColor.r
		DF_config.iconbars[1].textColor.v=DF_config.icons.textColor.v
		DF_config.iconbars[1].textColor.b=DF_config.icons.textColor.b

		DF_config.iconbars[2].fontSize=DF_config.icons.fontSize
		DF_config.iconbars[2].orderByTime=DF_config.icons.orderByTime
		DF_config.iconbars[2].decimal=DF_config.icons.decimal
		DF_config.iconbars[2].automatic=DF_config.icons.automatic
		DF_config.iconbars[2].showSpiral=DF_config.icons.showSpiral
		DF_config.iconbars[2].inactiveAlpha=DF_config.icons.inactiveAlpha
		DF_config.iconbars[2].level=DF_config.icons.level
		DF_config.iconbars[2].textsoffsets[1].visible=DF_config.icons.textsoffsets[1].visible
		DF_config.iconbars[2].textsoffsets[1].offsety=DF_config.icons.textsoffsets[1].offsety
		DF_config.iconbars[2].textsoffsets[1].align=DF_config.icons.textsoffsets[1].align
		DF_config.iconbars[2].textsoffsets[1].offsetx=DF_config.icons.textsoffsets[1].offsetx
		DF_config.iconbars[2].textsoffsets[1].size=DF_config.icons.textsoffsets[1].size
		DF_config.iconbars[2].textsoffsets[2].visible=DF_config.icons.textsoffsets[2].visible
		DF_config.iconbars[2].textsoffsets[2].offsety=DF_config.icons.textsoffsets[2].offsety
		DF_config.iconbars[2].textsoffsets[2].align=DF_config.icons.textsoffsets[2].align
		DF_config.iconbars[2].textsoffsets[2].offsetx=DF_config.icons.textsoffsets[2].offsetx
		DF_config.iconbars[2].textsoffsets[2].size=DF_config.icons.textsoffsets[2].size
		DF_config.iconbars[2].textsoffsets[3].visible=DF_config.icons.textsoffsets[3].visible
		DF_config.iconbars[2].textsoffsets[3].offsety=DF_config.icons.textsoffsets[3].offsety
		DF_config.iconbars[2].textsoffsets[3].align=DF_config.icons.textsoffsets[3].align
		DF_config.iconbars[2].textsoffsets[3].offsetx=DF_config.icons.textsoffsets[3].offsetx
		DF_config.iconbars[2].textsoffsets[3].size=DF_config.icons.textsoffsets[3].size
		DF_config.iconbars[2].colonne=DF_config.icons.colonne2
		DF_config.iconbars[2].fontPath=DF_config.icons.fontPath
		DF_config.iconbars[2].mode=DF_config.icons.mode
		DF_config.iconbars[2].pointpa=DF_config.icons.pointpa
		DF_config.iconbars[2].width=DF_config.icons.width2
		DF_config.iconbars[2].height=DF_config.icons.height2
		DF_config.iconbars[2].speed=DF_config.icons.speed
		DF_config.iconbars[2].pulse=DF_config.icons.pulse
		DF_config.iconbars[2].activeAlpha=DF_config.icons.activeAlpha
		DF_config.iconbars[2].growup=DF_config.icons.growup
		DF_config.iconbars[2].textColor.a=DF_config.icons.textColor.a
		DF_config.iconbars[2].textColor.r=DF_config.icons.textColor.r
		DF_config.iconbars[2].textColor.v=DF_config.icons.textColor.v
		DF_config.iconbars[2].textColor.b=DF_config.icons.textColor.b

		-- ajout gestion blood in the water
		table.insert(DF_config.spells, 1, {})
		DF_namespace:copyTable(DF_namespace.DefaultSpell,DF_config.spells[1],true)
		
		DF_config.spells[1].spellIDs="0"
		DF_config.spells[1].sType="Custom"
		DF_config.spells[1].abiUserText="Blood in the water"
	
		DF_config.spells[1].icon=0
		DF_config.spells[1].timerbar=0
		DF_config.spells[1].luaCode="current = UnitHealth(\"target\")\nmaxi = UnitHealthMax(\"target\")\npercent = current/maxi\nif percent<0.25 then\nreturn true\nelse\nreturn false\nend\n"	
		
		DF_config.spells[1].FX_enable=true
		DF_config.spells[1].FX_positionx=74
		DF_config.spells[1].FX_positiony=-38
		DF_config.spells[1].FX_width=128
		DF_config.spells[1].FX_height=128
		DF_config.spells[1].FX_level=127
		DF_config.spells[1].FX_mode="BLEND"
		DF_config.spells[1].FX_texture="Interface\\AddOns\\DroodFocus\\datas\\fx_glow10.tga"

		DF_config.spells[1].FX_start_scale=1.25
		DF_config.spells[1].FX_middle_scale=1.25
		DF_config.spells[1].FX_end_scale=1.25

		DF_config.spells[1].FX_start_posx=0
		DF_config.spells[1].FX_middle_posx=0
		DF_config.spells[1].FX_end_posx=-0
		
		DF_config.spells[1].FX_start_posy=250
		DF_config.spells[1].FX_middle_posy=0
		DF_config.spells[1].FX_end_posy=-65	

		DF_config.spells[1].FX_start_alpha=0
		DF_config.spells[1].FX_middle_alpha=0.65
		DF_config.spells[1].FX_end_alpha=0

		DF_config.spells[1].FX_start_height=0
		DF_config.spells[1].FX_middle_height=1
		DF_config.spells[1].FX_end_height=0.5

		DF_config.spells[1].FX_speed=5

		DF_config.spells[1].FX_pulsepowerZ=0.5
		DF_config.spells[1].FX_pulsespeedZ=2
		DF_config.spells[1].FX_rotatespeed=0
		DF_config.spells[1].FX_chakerpower=0		

	end
		
end

--
-- configurations prédéfinies
-- 
DF_pred_configs = {
	-- DEBUT [BuildIn] DroodFocus Default
	{
		["configversion"] = 427,
		["MiniMapAngle"] = 215.8160744865155,
		["portrait"] = {
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\datas\\empty.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\datas\\bearform.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\datas\\aquaform.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\datas\\catform.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\datas\\travelform.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\datas\\moonkinform.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\datas\\flightform.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\datas\\treeform.tga", -- [8]
			},
			["positionx"] = 1,
			["level"] = 5,
			["positiony"] = 1.5,
			["enable"] = true,
			["mode"] = "ADD",
			["height"] = "48",
			["width"] = "48",
		},
		["powerbar"] = {
			["fontSize"] = 15,
			["positiony"] = -18.5,
			["enable"] = true,
			["showSpark"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["colorNrj"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 0,
			},
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["interval"] = 1,
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["r"] = 0.5,
				["v"] = 0.5,
				["b"] = 0.5,
			},
			["sformat"] = "#c",
			["texty"] = 2,
			["height"] = 32,
			["textx"] = -4,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorMana"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 1,
			},
			["enableArrows"] = true,
			["arrows"] = {
				33876, -- [1]
				5221, -- [2]
				80, -- [3]
				1079, -- [4]
				-1, -- [5]
				-1, -- [6]
			},
			["width"] = 192,
			["showText"] = true,
			["colorRage"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["orientation"] = "HORIZONTAL",
			["positionx"] = 10,
			["textAlign"] = "BOTTOMRIGHT",
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["threatbar"] = {
			["fontSize"] = 8,
			["positiony"] = "-50",
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#c%",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["width"] = 192,
			["texty"] = 0,
			["positionx"] = "10",
			["showText"] = true,
			["height"] = "10",
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "RIGHT",
			["textx"] = -4,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["gridSizeX"] = 1,
		["optionsScale"] = 1,
		["sound"] = {
			["enable"] = true,
			["soundfiles"] = {
				"", -- [1]
				"Sound\\Spells\\Druid_Pounce.wav", -- [2]
				"", -- [3]
				"Sound\\Spells\\Druid_FeralCharge.wav", -- [4]
				"", -- [5]
				"", -- [6]
				"", -- [7]
				"", -- [8]
			},
		},
		["timelines"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["enable"] = false,
			["activeAlpha"] = 0.1,
			["width"] = 1,
		},
		["activeForms"] = {
			false, -- [1]
			true, -- [2]
			false, -- [3]
			true, -- [4]
			false, -- [5]
			false, -- [6]
			false, -- [7]
			false, -- [8]
		},
		["anchor5"] = {
			["visible"] = true,
			["positiony"] = -102,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "INFOS",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 18,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor3"] = {
			["visible"] = true,
			["positiony"] = -85.75,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 1",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = "35.5",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["icons"] = {
			["fontSize"] = 13,
			["orderByTime"] = true,
			["decimal"] = false,
			["automatic"] = true,
			["showSpiral"] = 1,
			["inactiveAlpha"] = 0.3,
			["level"] = 10,
			["height2"] = 37,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["textsoffsets"] = {
				{
					["visible"] = true,
					["offsety"] = -2,
					["align"] = "TOP",
					["offsetx"] = 0,
					["size"] = 14,
				}, -- [1]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMRIGHT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [2]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMLEFT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [3]
			},
			["colonne"] = 8,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["speed"] = 4,
			["pointpa"] = true,
			["width"] = 37,
			["height"] = 37,
			["enable"] = true,
			["pulse"] = 1.6,
			["activeAlpha"] = 1,
			["width2"] = 37,
			["growup"] = false,
			["mode"] = "BLEND",
			["colonne2"] = 8,
		},
		["blood"] = {
			["persistence"] = 15,
			["mode"] = "BLEND",
			["alpha"] = 0.7,
			["enable"] = true,
			["level"] = 1,
			["NotInRaid"] = true,
			["size"] = 0.7,
		},
		["anchor4"] = {
			["visible"] = true,
			["positiony"] = -84.75,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 2",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = "230",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor7"] = {
			["visible"] = true,
			["positiony"] = 130,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 2",
			["level"] = 1,
			["height"] = 32,
			["positionx"] = -186,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["haveTarget"] = false,
		["alignToGrid"] = true,
		["inCombat"] = false,
		["configname"] = "[BuildIn] DroodFocus",
		["combo"] = {
			["fontSize"] = 18,
			["positiony"] = "-21",
			["enable"] = true,
			["textOffsetX"] = 12,
			["impulsion"] = 1.75,
			["mode"] = "BLEND",
			["angleA"] = 288,
			["level"] = 4,
			["offsety"] = 0,
			["ptype"] = 1,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				true, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\combo.tga",
			["width"] = 21,
			["positionx"] = 51.66293145777689,
			["angleB"] = 183,
			["showText"] = false,
			["textOffsetY"] = -17,
			["height"] = 21,
			["offsetx"] = 20,
			["rayon"] = 37,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["anchor0"] = {
			["visible"] = true,
			["positiony"] = 279,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "GLOBAL",
			["positionx"] = 626,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor6"] = {
			["visible"] = true,
			["positiony"] = -34.75,
			["scale"] = 1,
			["width"] = "32",
			["info"] = "CD",
			["positionx"] = -12.75,
			["height"] = "32",
			["level"] = 10,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["minimap"] = true,
		["targetbar"] = {
			["fontSize"] = 11,
			["positiony"] = -6,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%) #t",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.75,
				["b"] = 0,
			},
			["width"] = 192,
			["texty"] = 0,
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["height"] = "13",
			["orientation"] = "HORIZONTAL",
			["positionx"] = 10,
			["textx"] = -4,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["cursorspeed"] = 30,
		["uiAlwaysShow"] = false,
		["timerbar"] = {
			["activeAlpha"] = 1,
			["cdColor"] = {
				["a"] = 0.4900000095367432,
				["r"] = 1,
				["v"] = 1,
				["b"] = 0,
			},
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 4,
			["height2"] = "22",
			["prop2"] = true,
			["growup"] = false,
			["font1Size"] = 12,
			["timeline"] = 14,
			["cdoffsety"] = 2,
			["height"] = "22",
			["activeAlpha2"] = 1,
			["orderByTime"] = true,
			["enable"] = true,
			["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["border"] = true,
			["prop"] = true,
			["borderSize"] = 1,
			["activeAlphaCD"] = 1,
			["cdoffsetx"] = 0,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["textsoffsets"] = {
				{
					["offsety"] = 1,
					["offsetx"] = 0,
				}, -- [1]
				{
					["offsety"] = 0,
					["offsetx"] = 2,
				}, -- [2]
			},
			["activeAlphaCD2"] = 1,
			["stackup2"] = true,
			["width"] = "257.25",
			["stackup1"] = false,
			["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["showTimeLine"] = true,
			["font2Size"] = 20,
			["width2"] = "257.25",
			["inactiveAlpha2"] = 0,
			["showSpark"] = true,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["gridSizeY"] = 1,
		["gps"] = {
			["fontSize"] = 14,
			["gpsTarget"] = {
				"target", -- [1]
				"focus", -- [2]
			},
			["positiony"] = 202.6987448411231,
			["enable"] = false,
			["offsety"] = -22,
			["alpha"] = 1,
			["width"] = 40,
			["mode"] = "BLEND",
			["level"] = 10,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["offsetx"] = 0,
			["height"] = 40,
			["positionx"] = 0,
			["positions"] = {
				{
					["y"] = 395.5107913354188,
					["x"] = 562.8306660144348,
				}, -- [1]
				{
					["y"] = 328.4352563300768,
					["x"] = 562.8308761000344,
				}, -- [2]
				{
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["timerbars"] = {
			{
				["orderByTime"] = true,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpark"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.4900000095367432,
					["r"] = 1,
					["v"] = 1,
					["b"] = 0,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 1,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = false,
				["inactiveAlpha"] = 0,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["activeAlpha"] = 1,
				["growup"] = false,
				["font2Size"] = 20,
				["font1Size"] = 12,
				["width"] = "257.25",
				["timeline"] = 14,
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["borderColor"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 0,
					["b"] = 0,
				},
				["height"] = "22",
				["cdoffsetx"] = 0,
				["border"] = true,
				["textColor"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
			}, -- [1]
			{
				["orderByTime"] = true,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpark"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.4900000095367432,
					["r"] = 1,
					["v"] = 1,
					["b"] = 0,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 1,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = true,
				["inactiveAlpha"] = 0,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["activeAlpha"] = 1,
				["growup"] = false,
				["font2Size"] = 20,
				["font1Size"] = 12,
				["width"] = "257.25",
				["timeline"] = 14,
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["borderColor"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 0,
					["b"] = 0,
				},
				["height"] = "22",
				["cdoffsetx"] = 0,
				["border"] = true,
				["textColor"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
			}, -- [2]
		},
		["cooldown"] = {
			["offsety"] = -48,
			["positiony"] = -1.000137314198355,
			["enable"] = true,
			["alpha"] = 0.7,
			["width"] = 49,
			["offsetx"] = 0,
			["height"] = 49,
			["positionx"] = 199.9999970197678,
			["level"] = 5,
			["mode"] = "BLEND",
		},
		["castbar"] = {
			["fontSize"] = 12,
			["border"] = true,
			["positiony"] = 58.5,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 1,
				["b"] = 0,
			},
			["borderSize"] = 2,
			["impulsion"] = 1,
			["positionx"] = 10,
			["height"] = 24,
			["timerAlign"] = "RIGHT",
			["timerColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["texty"] = 0,
			["timerx"] = -3,
			["timery"] = 0,
			["showSpark"] = true,
			["width"] = 192,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["textx"] = 3,
			["showTimer"] = true,
			["fontSizetimer"] = 16,
			["fontPathtimer"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["enable"] = true,
			["showText"] = true,
			["colori"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "LEFT",
			["activeAlpha"] = 1,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["manabar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 1,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -7,
			["width"] = 192,
			["texty"] = 1,
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["enable"] = false,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["spells"] = {
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 0,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 0.65,
				["abiInternalCD"] = 0,
				["FX_speed"] = 5,
				["sType"] = "Custom",
				["positionx"] = 64,
				["FX_positionx"] = 74,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 2,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1.25,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "0",
				["abiStack"] = 0,
				["FX_start_posy"] = 250,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Inconnu",
				["ids"] = {
					0, -- [1]
				},
				["FX_mode"] = "BLEND",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiLast"] = 0,
				["FX_timersmall"] = true,
				["abiFake"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiEnd"] = 0,
				["abiDuration"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 0.5,
				["FX_level"] = 127,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_textoffsetx"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerposy"] = 0,
				["FX_pulsepowerZ"] = 0.5,
				["FX_start_scale"] = 1.25,
				["combo"] = false,
				["abiUserText"] = "Blood in the water",
				["FX_textoffsety"] = -40,
				["FX_customtexture"] = "",
				["names"] = {
					"Inconnu", -- [1]
				},
				["FX_start_height"] = 0,
				["FX_end_scale"] = 1.25,
				["FX_end_posx"] = 0,
				["FX_name"] = "Custom",
				["FX_timeralpha"] = 0.35,
				["showdottimer"] = true,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_glow10.tga",
				["strongcheck"] = false,
				["FX_middle_width"] = 1,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_rotatespeed"] = 0,
				["FX_stack"] = 0,
				["FX_end_posy"] = -65,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_timerabove"] = false,
				["luaCode"] = "current = UnitHealth(\"target\")\nmaxi = UnitHealthMax(\"target\")\npercent = current/maxi\nif percent<0.25 then\nreturn true\nelse\nreturn false\nend\n",
				["FX_timerenable"] = false,
				["FX_textalign"] = "CENTER",
				["FX_start_posx"] = 0,
				["FX_positiony"] = -38,
			}, -- [1]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 0,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 50,
				["sType"] = "Custom",
				["positionx"] = 0,
				["FX_positionx"] = 72,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = "128",
				["FX_stack"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "0",
				["abiStack"] = 0,
				["timerbar"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_pulsepowerY"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 2.5,
				["FX_textalign"] = "CENTER",
				["abiEnd"] = 0,
				["abiLast"] = 0,
				["FX_level"] = 10,
				["combo"] = false,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_start_alpha"] = 0,
				["FX_timersmall"] = false,
				["FX_mode"] = "BLEND",
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posx"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_customtexture"] = "",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_middle_width"] = 1,
				["FX_pulsepowerZ"] = 0.5,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "ComboPoint",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0,
				["names"] = {
					"Inconnu", -- [1]
				},
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_combo.tga",
				["FX_end_posx"] = 0,
				["showdottimer"] = true,
				["FX_textoffsetx"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["comboPoints"] = 5,
				["FX_end_scale"] = 3,
				["FX_start_height"] = 1,
				["abiFake"] = 0,
				["strongcheck"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "HeartBeat",
				["FX_middle_alpha"] = 1,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["ids"] = {
					0, -- [1]
				},
				["abiSpelltext"] = "Inconnu",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 76,
			}, -- [2]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 81022,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 74,
				["decimal"] = false,
				["FX_angle"] = 21,
				["FX_height"] = "128",
				["abiSpelltext"] = "Ruée",
				["FX_end_width"] = 0,
				["FX_width"] = "128",
				["FX_stack"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					81022, -- [1]
				},
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "81022",
				["abiStack"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posy"] = 0,
				["FX_end_posx"] = -120,
				["timerbar"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 0,
				["abiCD"] = 0,
				["abiLastCd"] = 2.769000000000233,
				["FX_chakerpower"] = 1,
				["showdottimer"] = true,
				["FX_pulsespeedZ"] = 22,
				["FX_customtexture"] = "tiger",
				["abiEnd"] = 0,
				["FX_timerscale"] = 0.65,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_name"] = "FromRight",
				["FX_timersmall"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["strongcheck"] = false,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["abiDuration"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_textoffsety"] = -40,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["abiFake"] = 0,
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1.1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["showaura"] = false,
				["names"] = {
					"Ruée", -- [1]
				},
				["FX_timerenable"] = false,
				["showcd"] = true,
				["height"] = 32,
				["perso"] = true,
				["FX_timeralpha"] = 0.3,
				["FX_end_scale"] = 1.1,
				["comboPoints"] = 0,
				["FX_middle_posx"] = 0,
				["FX_timerposy"] = 0,
				["FX_middle_width"] = 1,
				["abiRipFix"] = 0,
				["FX_level"] = 10,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_middle_alpha"] = 1,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1.1,
				["FX_textenabled"] = false,
				["FX_start_posx"] = 120,
				["FX_positiony"] = 209,
			}, -- [3]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16870,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 72,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = "150",
				["abiSpelltext"] = "Idées claires",
				["FX_end_width"] = 1,
				["FX_width"] = "650",
				["FX_stack"] = 0,
				["FX_pulsespeed"] = 18,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					16870, -- [1]
				},
				["FX_rotatespeed"] = 0.5,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "16870",
				["abiStack"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["timerbar"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 1.935000000004948,
				["FX_chakerpower"] = 1,
				["showdottimer"] = true,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_middle_alpha"] = 1,
				["FX_timerscale"] = 0.9,
				["FX_end_scale"] = 2.5,
				["FX_start_alpha"] = 0,
				["FX_timersmall"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga",
				["strongcheck"] = false,
				["FX_end_posy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["combo"] = false,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["abiFake"] = 0,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 2.5,
				["names"] = {
					"Idées claires", -- [1]
				},
				["height"] = 32,
				["showcd"] = true,
				["perso"] = true,
				["FX_timerposy"] = 0,
				["FX_timeralpha"] = 1,
				["FX_middle_posy"] = 0,
				["comboPoints"] = 0,
				["FX_level"] = 10,
				["FX_end_posx"] = 0,
				["FX_middle_width"] = 1,
				["sType"] = "BuffPlayer",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_pulsepower"] = 0.15,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["abiEnd"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1.25,
				["FX_textenabled"] = false,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 76,
			}, -- [4]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22842,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Régénération frénétique",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["FX_stack"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					22842, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerX"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 1,
				["spellIDs"] = "22842",
				["abiStack"] = 0,
				["timerbar"] = 2,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_pulsespeedZ"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_textenabled"] = false,
				["getUptime"] = false,
				["alwaysVisible"] = false,
				["showcd"] = true,
				["FX_start_alpha"] = 1,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["strongcheck"] = false,
				["FX_end_posy"] = 0,
				["sType"] = "BuffPlayer",
				["FX_timerenable"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_textoffsety"] = -40,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_middle_width"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Régénération frénétique", -- [1]
				},
				["abiEnd"] = 0,
				["FX_start_height"] = 1,
				["FX_middle_posx"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.1215686274509804,
					["r"] = 0.02352941176470588,
				},
				["FX_timeralpha"] = 0.25,
				["FX_rotatespeed"] = 0,
				["comboPoints"] = 0,
				["showaura"] = false,
				["FX_start_scale"] = 1,
				["abiFake"] = 0,
				["FX_middle_posy"] = 0,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_level"] = 10,
				["FX_timerabove"] = true,
				["luaCode"] = "",
				["FX_middle_scale"] = 1,
				["FX_timerscale"] = 0.85,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [5]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 52610,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "52610",
				["abiStack"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_start_posy"] = 0,
				["FX_end_posx"] = 0,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 29.77999999999884,
				["FX_chakerpower"] = 0,
				["ids"] = {
					52610, -- [1]
				},
				["luaCode"] = "",
				["alwaysVisible"] = false,
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 1,
				["FX_end_scale"] = 1,
				["abiLast"] = 0,
				["FX_timersmall"] = false,
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["height"] = 32,
				["FX_textoffsetx"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["perso"] = false,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_middle_width"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["combo"] = false,
				["names"] = {
					"Rugissement sauvage", -- [1]
				},
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiDuration"] = 0,
				["showdottimer"] = true,
				["strongcheck"] = false,
				["FX_timeralpha"] = 0.25,
				["sType"] = "BuffPlayer",
				["comboPoints"] = 0,
				["FX_pulsepowerY"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["abiFake"] = 0,
				["abiSpelltext"] = "Rugissement sauvage",
				["FX_level"] = 10,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_timerposy"] = 0,
				["abiEnd"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [6]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 61336,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					61336, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "61336",
				["abiStack"] = 0,
				["FX_textenabled"] = false,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 0.0392156862745098,
					["v"] = 0.192156862745098,
					["b"] = 1,
				},
				["FX_level"] = 10,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["showdottimer"] = true,
				["luaCode"] = "",
				["FX_customtexture"] = "",
				["FX_end_posx"] = 0,
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_alpha"] = 1,
				["FX_timersmall"] = false,
				["abiRipFix"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_textoffsetx"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_mode"] = "ADD",
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["abiFake"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_start_height"] = 1,
				["names"] = {
					"Instincts de survie", -- [1]
				},
				["FX_textalign"] = "CENTER",
				["combo"] = false,
				["strongcheck"] = false,
				["FX_start_scale"] = 1,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 1,
				["FX_middle_width"] = 1,
				["abiSpelltext"] = "Instincts de survie",
				["showcd"] = true,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_timerposy"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["sType"] = "BuffPlayer",
				["FX_rotatespeed"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [7]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 467,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					467, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "467",
				["abiStack"] = 0,
				["FX_textenabled"] = false,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["luaCode"] = "",
				["FX_customtexture"] = "",
				["showdottimer"] = true,
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_alpha"] = 1,
				["FX_timersmall"] = false,
				["abiRipFix"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["sType"] = "BuffPlayer",
				["FX_end_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_middle_width"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Epines", -- [1]
				},
				["FX_middle_posx"] = 0,
				["combo"] = false,
				["strongcheck"] = false,
				["perso"] = false,
				["FX_timeralpha"] = 0.25,
				["showcd"] = true,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsepowerY"] = 0,
				["abiFake"] = 0,
				["abiSpelltext"] = "Epines",
				["FX_level"] = 10,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_textoffsetx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_textalign"] = "CENTER",
				["FX_rotatespeed"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [8]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5229,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					5229, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "5229",
				["abiStack"] = 0,
				["FX_textenabled"] = false,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_level"] = 10,
				["luaCode"] = "",
				["FX_customtexture"] = "",
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_alpha"] = 1,
				["FX_timersmall"] = false,
				["strongcheck"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_textoffsetx"] = 0,
				["FX_mode"] = "ADD",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["abiFake"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["combo"] = false,
				["names"] = {
					"Enrager", -- [1]
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["perso"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0.06274509803921569,
					["v"] = 1,
					["b"] = 0.1450980392156863,
				},
				["abiRipFix"] = 0,
				["FX_timeralpha"] = 0.25,
				["sType"] = "BuffPlayer",
				["comboPoints"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_end_scale"] = 1,
				["FX_middle_width"] = 1,
				["abiSpelltext"] = "Enrager",
				["showdottimer"] = true,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["showcd"] = true,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_timerposy"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [9]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 8998,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					8998, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "8998",
				["abiStack"] = 0,
				["FX_textenabled"] = false,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.1647058823529412,
					["r"] = 0.01176470588235294,
				},
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["luaCode"] = "",
				["FX_customtexture"] = "",
				["showdottimer"] = true,
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_alpha"] = 1,
				["FX_timersmall"] = false,
				["abiRipFix"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["sType"] = "BuffPlayer",
				["FX_end_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_middle_width"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Dérobade", -- [1]
				},
				["FX_middle_posx"] = 0,
				["combo"] = false,
				["strongcheck"] = false,
				["perso"] = false,
				["FX_timeralpha"] = 0.25,
				["showcd"] = true,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsepowerY"] = 0,
				["abiFake"] = 0,
				["abiSpelltext"] = "Dérobade",
				["FX_level"] = 10,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_textoffsetx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_textalign"] = "CENTER",
				["FX_rotatespeed"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [10]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1850,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					1850, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "1850",
				["abiStack"] = 0,
				["FX_textenabled"] = false,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0.1176470588235294,
					["v"] = 1,
					["r"] = 0.02745098039215686,
				},
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["luaCode"] = "",
				["FX_customtexture"] = "",
				["FX_level"] = 10,
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_alpha"] = 1,
				["FX_timersmall"] = false,
				["strongcheck"] = false,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["sType"] = "BuffPlayer",
				["FX_end_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_middle_width"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Célérité", -- [1]
				},
				["FX_middle_posx"] = 0,
				["combo"] = false,
				["abiRipFix"] = 0,
				["perso"] = false,
				["FX_timeralpha"] = 0.25,
				["showcd"] = true,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsepowerY"] = 0,
				["abiFake"] = 0,
				["abiSpelltext"] = "Célérité",
				["showdottimer"] = true,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_textoffsetx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_textalign"] = "CENTER",
				["FX_rotatespeed"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [11]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80964,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					80964, -- [1]
					80965, -- [2]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["FX_stack"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "80964;80965",
				["abiStack"] = 0,
				["FX_textenabled"] = false,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["luaCode"] = "",
				["FX_customtexture"] = "",
				["FX_level"] = 10,
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_alpha"] = 1,
				["FX_timersmall"] = false,
				["abiRipFix"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["showcd"] = true,
				["FX_end_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_middle_width"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textoffsety"] = -40,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Coup de crâne", -- [1]
					"Coup de crâne", -- [2]
				},
				["sType"] = "DebuffTarget",
				["combo"] = false,
				["strongcheck"] = false,
				["perso"] = true,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsepowerY"] = 0,
				["abiFake"] = 0,
				["abiSpelltext"] = "Coup de crâne",
				["showdottimer"] = true,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_textoffsetx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_textalign"] = "CENTER",
				["FX_rotatespeed"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [12]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 91565,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Feu féerique",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["FX_stack"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["timerbar"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_middle_scale"] = 1,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 1,
				["spellIDs"] = "91565;7386;8647;35387;50498;770",
				["abiStack"] = 0,
				["showdottimer"] = true,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 0.9803921568627451,
					["v"] = 1,
					["b"] = 0,
				},
				["ids"] = {
					91565, -- [1]
					7386, -- [2]
					8647, -- [3]
					35387, -- [4]
					50498, -- [5]
					770, -- [6]
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["abiEnd"] = 0,
				["FX_timerscale"] = 0.85,
				["FX_name"] = "Custom",
				["abiUpTime"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiRipFix"] = 0,
				["FX_timersmall"] = false,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["abiLast"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_start_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerenable"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["names"] = {
					"Feu féerique", -- [1]
					"Fracasser armure", -- [2]
					"Exposer l'armure", -- [3]
					"Crachat corrosif", -- [4]
					"Déchirer armure", -- [5]
					"Lucioles", -- [6]
				},
				["FX_middle_posx"] = 0,
				["FX_end_posx"] = 0,
				["FX_start_height"] = 1,
				["height"] = 32,
				["FX_timeralpha"] = 0.25,
				["FX_level"] = 10,
				["comboPoints"] = 0,
				["showaura"] = false,
				["FX_customtexture"] = "",
				["FX_middle_width"] = 1,
				["FX_pulsespeedZ"] = 0,
				["FX_end_scale"] = 1,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_middle_alpha"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_pulsepowerX"] = 0,
				["FX_middle_posy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [13]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33876,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["ids"] = {
					33876, -- [1]
					33878, -- [2]
					46857, -- [3]
					50271, -- [4]
					35290, -- [5]
					16511, -- [6]
				},
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "33876;33878;46857;50271;35290;16511",
				["abiStack"] = 0,
				["FX_level"] = 10,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_name"] = "Custom",
				["FX_middle_alpha"] = 1,
				["FX_end_scale"] = 1,
				["abiRipFix"] = 0,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiEnd"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0.4117647058823529,
					["b"] = 0,
				},
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Mutilation", -- [1]
					"Mutilation", -- [2]
					"Traumatisme", -- [3]
					"Déchirure du tendon", -- [4]
					"Encorner", -- [5]
					"Hémorragie", -- [6]
				},
				["FX_mode"] = "ADD",
				["perso"] = false,
				["showaura"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["abiLast"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["abiSpelltext"] = "Mutilation",
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [14]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1822,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["ids"] = {
					1822, -- [1]
				},
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "1822",
				["abiStack"] = 0,
				["FX_level"] = 10,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_name"] = "Custom",
				["FX_middle_alpha"] = 1,
				["FX_end_scale"] = 1,
				["abiRipFix"] = 0,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiEnd"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Griffure", -- [1]
				},
				["FX_mode"] = "ADD",
				["perso"] = true,
				["showaura"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["abiLast"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["abiSpelltext"] = "Griffure",
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [15]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33745,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["ids"] = {
					33745, -- [1]
				},
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "33745",
				["abiStack"] = 0,
				["FX_level"] = 10,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_name"] = "Custom",
				["FX_middle_alpha"] = 1,
				["FX_end_scale"] = 1,
				["abiRipFix"] = 0,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiEnd"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = true,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Lacérer", -- [1]
				},
				["FX_mode"] = "ADD",
				["perso"] = true,
				["showaura"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["abiLast"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["abiSpelltext"] = "Lacérer",
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [16]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1079,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["ids"] = {
					1079, -- [1]
				},
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "1079",
				["abiStack"] = 0,
				["FX_level"] = 10,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_name"] = "Custom",
				["FX_middle_alpha"] = 1,
				["FX_end_scale"] = 1,
				["abiRipFix"] = 0,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiEnd"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Déchirure", -- [1]
				},
				["FX_mode"] = "ADD",
				["perso"] = true,
				["showaura"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["abiLast"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["abiSpelltext"] = "Déchirure",
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [17]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 99,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["ids"] = {
					99, -- [1]
					1160, -- [2]
					702, -- [3]
					26016, -- [4]
					26017, -- [5]
				},
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "99;1160;702;26016;26017",
				["abiStack"] = 0,
				["FX_level"] = 10,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_name"] = "Custom",
				["FX_middle_alpha"] = 1,
				["FX_end_scale"] = 1,
				["abiRipFix"] = 0,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiEnd"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0.4470588235294117,
					["r"] = 1,
				},
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Rugissement démoralisant", -- [1]
					"Cri démoralisant", -- [2]
					"Malédiction de faiblesse", -- [3]
					"Justification", -- [4]
					"Justification", -- [5]
				},
				["showaura"] = false,
				["perso"] = false,
				["FX_pulsespeedY"] = 0,
				["height"] = 32,
				["FX_timeralpha"] = 0.25,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["abiLast"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiSpelltext"] = "Rugissement démoralisant",
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [18]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80951,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_rotatespeed"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "80951",
				["abiStack"] = 0,
				["showdottimer"] = true,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0.1411764705882353,
					["v"] = 1,
					["r"] = 0,
				},
				["ids"] = {
					80951, -- [1]
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 1,
				["alwaysVisible"] = false,
				["FX_end_scale"] = 1,
				["strongcheck"] = false,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["showaura"] = false,
				["FX_middle_posx"] = 0,
				["FX_start_scale"] = 1,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["showcd"] = true,
				["names"] = {
					"Pulvérisation", -- [1]
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_start_height"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_mode"] = "ADD",
				["FX_timeralpha"] = 0.25,
				["FX_level"] = 10,
				["comboPoints"] = 0,
				["FX_end_posx"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_width"] = 1,
				["FX_pulsespeedZ"] = 0,
				["FX_customtexture"] = "",
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["abiEnd"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiSpelltext"] = "Pulvérisation",
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [19]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 69369,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Rapidité du prédateur",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_textalign"] = "CENTER",
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "69369",
				["abiStack"] = 0,
				["showdottimer"] = true,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["ids"] = {
					69369, -- [1]
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 11.16700000000128,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["abiRipFix"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_alpha"] = 1,
				["alwaysVisible"] = false,
				["FX_end_scale"] = 1,
				["strongcheck"] = false,
				["FX_timersmall"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_timerposy"] = 0,
				["FX_start_height"] = 1,
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_posx"] = 0,
				["names"] = {
					"Rapidité du prédateur", -- [1]
				},
				["showaura"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_mode"] = "ADD",
				["FX_pulsespeedY"] = 0,
				["FX_timeralpha"] = 0.25,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_customtexture"] = "",
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_pulsepowerX"] = 0,
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [20]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 50334,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 60,
				["FX_customtexture"] = "paw",
				["positionx"] = 0,
				["FX_positionx"] = 139,
				["FX_angle"] = 3,
				["FX_height"] = "128",
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = "128",
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_rotatespeed"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.35,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "50334",
				["abiStack"] = 0,
				["FX_middle_posx"] = 0,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["ids"] = {
					50334, -- [1]
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 3,
				["luaCode"] = "",
				["FX_middle_posy"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 0,
				["alwaysVisible"] = false,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["strongcheck"] = true,
				["FX_timersmall"] = true,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_pulsespeedZ"] = 18,
				["FX_level"] = 10,
				["abiDuration"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1.8,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_end_posx"] = 0,
				["names"] = {
					"Berserk", -- [1]
				},
				["FX_start_height"] = 1,
				["abiUpTime"] = 0,
				["showaura"] = false,
				["height"] = 32,
				["FX_timeralpha"] = 0.35,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0.5411764705882353,
					["r"] = 1,
				},
				["comboPoints"] = 0,
				["abiEnd"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_width"] = 1,
				["showcd"] = true,
				["FX_end_scale"] = 2,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_name"] = "ZoomIn",
				["sType"] = "BuffPlayer",
				["FX_timerabove"] = false,
				["getUptime"] = false,
				["abiSpelltext"] = "Berserk",
				["FX_middle_scale"] = 0.6,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 97,
			}, -- [21]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5217,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 60,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 11,
				["FX_angle"] = 0,
				["FX_height"] = "72",
				["abiSpelltext"] = "Fureur du tigre",
				["FX_end_width"] = 1,
				["FX_width"] = "72",
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 3,
				["FX_textalign"] = "CENTER",
				["abiSound"] = "",
				["FX_timerscale"] = 0.35,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5217",
				["abiStack"] = 0,
				["showdottimer"] = true,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["ids"] = {
					5217, -- [1]
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 29.31000000000495,
				["FX_chakerpower"] = 1,
				["luaCode"] = "",
				["abiRipFix"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_alpha"] = 0,
				["alwaysVisible"] = false,
				["FX_end_scale"] = 3,
				["strongcheck"] = false,
				["FX_timersmall"] = true,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_timerposy"] = 0,
				["FX_start_height"] = 1,
				["abiDuration"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerenable"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 2.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_posx"] = 0,
				["names"] = {
					"Fureur du tigre", -- [1]
				},
				["showaura"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.5764705882352941,
				},
				["FX_mode"] = "BLEND",
				["FX_pulsespeedY"] = 2.5,
				["FX_timeralpha"] = 0.35,
				["showcd"] = true,
				["comboPoints"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["FX_end_posx"] = 0,
				["sType"] = "BuffPlayer",
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "ZoomIn",
				["FX_customtexture"] = "lion",
				["FX_timerabove"] = false,
				["getUptime"] = false,
				["FX_pulsepowerX"] = 0,
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 97,
			}, -- [22]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 0,
				["FX_enable"] = false,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22812,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 23,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Ecorce",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_stack"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "22812",
				["abiStack"] = 0,
				["FX_middle_posx"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["ids"] = {
					22812, -- [1]
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["luaCode"] = "",
				["abiEnd"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 1,
				["FX_middle_scale"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["strongcheck"] = false,
				["FX_timersmall"] = false,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_pulsespeedZ"] = 0,
				["height"] = 32,
				["FX_start_scale"] = 1,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["abiFake"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_timerenable"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_end_posx"] = 0,
				["names"] = {
					"Ecorce", -- [1]
				},
				["showaura"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.6039215686274509,
				},
				["perso"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_timeralpha"] = 0.25,
				["sType"] = "BuffPlayer",
				["comboPoints"] = 0,
				["FX_end_scale"] = 1,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_middle_width"] = 1,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["alwaysVisible"] = false,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_middle_posy"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [23]
		},
		["anchor8"] = {
			["visible"] = true,
			["positiony"] = -128,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "DOTS",
			["positionx"] = 128,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["iconbars"] = {
			{
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["automatic"] = true,
				["activeAlpha"] = 1,
				["speed"] = 4,
				["mode"] = "BLEND",
				["height2"] = 37,
				["colonne2"] = 8,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOPLEFT",
						["offsetx"] = 1,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [3]
				},
				["enable"] = true,
				["growup"] = false,
				["level"] = 10,
				["pointpa"] = true,
				["width"] = 37,
				["width2"] = 37,
				["colonne"] = 8,
				["showSpiral"] = 1,
				["pulse"] = 1.6,
				["height"] = 37,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["inactiveAlpha"] = 0.3,
				["textColor"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
			}, -- [1]
			{
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["automatic"] = true,
				["showSpiral"] = 1,
				["inactiveAlpha"] = 0.3,
				["level"] = 10,
				["height2"] = 37,
				["colonne2"] = 8,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOP",
						["offsetx"] = 0,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [3]
				},
				["mode"] = "BLEND",
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["enable"] = true,
				["pointpa"] = true,
				["width"] = 37,
				["width2"] = 37,
				["colonne"] = 8,
				["speed"] = 4,
				["pulse"] = 1.6,
				["height"] = 37,
				["activeAlpha"] = 1,
				["growup"] = false,
				["textColor"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
			}, -- [2]
		},
		["anchor1"] = {
			["visible"] = true,
			["positiony"] = -32,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "UI",
			["positionx"] = 32,
			["height"] = 32,
			["level"] = 1,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["ooc"] = {
			["spell"] = 12536,
			["positiony"] = 17,
			["enable"] = true,
			["scaleMin"] = 1,
			["width"] = "650",
			["textureOff"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
			["speed"] = 0.1,
			["scaleMax"] = 0.1,
			["textureOn"] = "Interface\\AddOns\\DroodFocus\\datas\\ooc.tga",
			["height"] = "150",
			["positionx"] = 70,
			["level"] = 10,
			["mode"] = "ADD",
		},
		["fixrip"] = false,
		["infos"] = {
			["fontSize"] = 8,
			["enable"] = false,
			["infolines"] = "PA: #meleeAP (#maxAP)*CC: #meleeCrit (#maxCrit%)*SD: #savagedef",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["level"] = 20,
			["backColor"] = {
				["a"] = 0,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["textColor"] = {
				["a"] = 0.4600000381469727,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["anchor2"] = {
			["visible"] = true,
			["positiony"] = 8.75,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 1",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 34,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["eclipsebar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0.5,
				["b"] = 1,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["textx"] = -7,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textAlign"] = "RIGHT",
			["width"] = 192,
			["color2"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["texty"] = 1,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["enable"] = false,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["alert"] = {
			["texture1"] = "Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga",
			["positiony"] = 125.3541556976384,
			["enable"] = true,
			["texture3"] = "Interface\\AddOns\\DroodFocus\\datas\\alertSkull.tga",
			["width"] = "48",
			["texture2"] = "Interface\\AddOns\\DroodFocus\\datas\\alertRange.tga",
			["persistence"] = 7,
			["positionx"] = 74.85286888914709,
			["level"] = 5,
			["height"] = "48",
			["showDebuff"] = true,
			["mode"] = "BLEND",
			["showBuff"] = false,
		},
		["healthbar"] = {
			["fontSize"] = 12,
			["positiony"] = 40,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["colorBad"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["sformat"] = "#C k/#M k (#p%) #t",
			["colorAverage"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["colorGood"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 1,
				["b"] = 0,
			},
			["colorchg"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["level"] = 2,
			["width"] = 192,
			["positionx"] = 8,
			["height"] = 18,
			["showText"] = true,
			["texty"] = 1,
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "RIGHT",
			["textx"] = -7,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
	}, -- [4]
	-- FIN [BuildIn] DroodFocus Default
	-- DEBUT [BuildIn] Moonkin
	{
		["configversion"] = 420,
		["MiniMapAngle"] = 215.8160744865155,
		["portrait"] = {
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\datas\\empty.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\datas\\bearform.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\datas\\aquaform.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\datas\\catform.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\datas\\travelform.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\datas\\moonkinform.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\datas\\flightform.tga", -- [7]
			},
			["height"] = "48",
			["level"] = 5,
			["positiony"] = 1.5,
			["enable"] = false,
			["mode"] = "ADD",
			["positionx"] = 1,
			["width"] = "48",
		},
		["powerbar"] = {
			["fontSize"] = 15,
			["positiony"] = -6,
			["enable"] = true,
			["showSpark"] = true,
			["colorNrj"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 0,
			},
			["borderSize"] = 2,
			["border"] = true,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["interval"] = 1,
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["r"] = 0.5,
				["v"] = 0.5,
				["b"] = 0.5,
			},
			["sformat"] = "#c",
			["positionx"] = 10,
			["height"] = "22",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["textx"] = -4,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorMana"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 1,
			},
			["colorRage"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["arrows"] = {
				"-1", -- [1]
				"-1", -- [2]
				"-1", -- [3]
				"-1", -- [4]
				-1, -- [5]
				-1, -- [6]
			},
			["width"] = 192,
			["showText"] = true,
			["enableArrows"] = true,
			["orientation"] = "HORIZONTAL",
			["texty"] = 2,
			["textAlign"] = "BOTTOMRIGHT",
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["threatbar"] = {
			["fontSize"] = 8,
			["positiony"] = "-50",
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#c%",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["enable"] = false,
			["width"] = 192,
			["texty"] = 0,
			["positionx"] = "10",
			["showText"] = true,
			["height"] = "10",
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "RIGHT",
			["textx"] = -4,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["gridSizeX"] = 1,
		["sound"] = {
			["enable"] = true,
			["soundfiles"] = {
				"", -- [1]
				"Sound\\Spells\\Druid_Pounce.wav", -- [2]
				"", -- [3]
				"Sound\\Spells\\Druid_FeralCharge.wav", -- [4]
				"", -- [5]
				"", -- [6]
				"", -- [7]
			},
		},
		["timelines"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["enable"] = false,
			["activeAlpha"] = 0.1,
			["width"] = 1,
		},
		["activeForms"] = {
			false, -- [1]
			false, -- [2]
			false, -- [3]
			false, -- [4]
			false, -- [5]
			true, -- [6]
			false, -- [7]
		},
		["anchor5"] = {
			["visible"] = true,
			["positiony"] = -102,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "INFOS",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 18,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor3"] = {
			["visible"] = true,
			["positiony"] = -53,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 1",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 229,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["icons"] = {
			["fontSize"] = 13,
			["orderByTime"] = true,
			["decimal"] = false,
			["automatic"] = true,
			["showSpiral"] = 1,
			["inactiveAlpha"] = 0.3,
			["level"] = 10,
			["textsoffsets"] = {
				{
					["visible"] = true,
					["offsety"] = -2,
					["align"] = "TOP",
					["offsetx"] = 0,
					["size"] = 14,
				}, -- [1]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMRIGHT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [2]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMLEFT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [3]
			},
			["colonne2"] = 8,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["mode"] = "BLEND",
			["pointpa"] = true,
			["width"] = 37,
			["colonne"] = 8,
			["speed"] = 4,
			["pulse"] = 1.6,
			["enable"] = true,
			["height"] = 37,
			["activeAlpha"] = 1,
			["growup"] = false,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["blood"] = {
			["persistence"] = 7,
			["mode"] = "BLEND",
			["enable"] = false,
			["level"] = 1,
			["NotInRaid"] = true,
			["size"] = 0.5,
		},
		["anchor4"] = {
			["visible"] = true,
			["positiony"] = 139,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 2",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 262,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor7"] = {
			["visible"] = true,
			["positiony"] = 130,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 2",
			["positionx"] = -186,
			["height"] = 32,
			["level"] = 1,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["haveTarget"] = false,
		["alignToGrid"] = true,
		["inCombat"] = false,
		["configname"] = "[BuildIn] DF Moonkin",
		["combo"] = {
			["fontSize"] = 18,
			["positiony"] = "-21",
			["enable"] = false,
			["textOffsetX"] = 12,
			["impulsion"] = 1.75,
			["level"] = 4,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\combo.tga",
			["angleA"] = 288,
			["offsety"] = 0,
			["ptype"] = 1,
			["angleB"] = 183,
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				true, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
				false, -- [8]
			},
			["mode"] = "BLEND",
			["width"] = 21,
			["positionx"] = 51.66293145777689,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showText"] = false,
			["textOffsetY"] = -17,
			["height"] = 21,
			["offsetx"] = 20,
			["rayon"] = 37,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["anchor0"] = {
			["visible"] = true,
			["positiony"] = 261,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "GLOBAL",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 621,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor6"] = {
			["visible"] = true,
			["positiony"] = -3,
			["scale"] = 1,
			["width"] = "32",
			["info"] = "CD",
			["positionx"] = -18,
			["height"] = "32",
			["level"] = 10,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["minimap"] = true,
		["targetbar"] = {
			["fontSize"] = 11,
			["positiony"] = -6,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.75,
				["b"] = 0,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%) #t",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["enable"] = false,
			["width"] = 192,
			["texty"] = 0,
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["height"] = "13",
			["orientation"] = "HORIZONTAL",
			["positionx"] = 10,
			["textx"] = -4,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["infos"] = {
			["fontSize"] = 8,
			["enable"] = false,
			["infolines"] = "PA: #meleeAP - Crit: #meleeCrit - Haste: #meleeHaste - Mastery: #mastery",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["level"] = 20,
			["backColor"] = {
				["a"] = 0,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["textColor"] = {
				["a"] = 0.4600000381469727,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["uiAlwaysShow"] = false,
		["timerbar"] = {
			["orderByTime"] = true,
			["enable"] = true,
			["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showSpark"] = true,
			["prop"] = true,
			["level"] = 4,
			["borderSize"] = 1,
			["cdColor"] = {
				["a"] = 0.4900000095367432,
				["r"] = 1,
				["v"] = 1,
				["b"] = 0,
			},
			["showTimeLine"] = true,
			["activeAlphaCD"] = 1,
			["stackup1"] = true,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["inactiveAlpha"] = 0,
			["activeAlpha"] = 1,
			["font2Size"] = 20,
			["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["prop2"] = false,
			["growup"] = false,
			["stackup2"] = true,
			["font1Size"] = 12,
			["width"] = "257.25",
			["timeline"] = 14,
			["textsoffsets"] = {
				{
					["offsety"] = 2,
					["offsetx"] = 0,
				}, -- [1]
				{
					["offsety"] = 0,
					["offsetx"] = 2,
				}, -- [2]
			},
			["cdoffsety"] = 2,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["height"] = "22",
			["cdoffsetx"] = 0,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["gridSizeY"] = 1,
		["gps"] = {
			["fontSize"] = 16,
			["gpsTarget"] = {
				"target", -- [1]
				"focus", -- [2]
			},
			["positiony"] = 202.6987448411231,
			["enable"] = false,
			["offsety"] = -22,
			["alpha"] = 1,
			["width"] = "40",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["offsetx"] = 0,
			["level"] = 10,
			["mode"] = "BLEND",
			["height"] = "40",
			["positionx"] = 0,
			["positions"] = {
				{
					["y"] = 395.5107913354188,
					["x"] = 562.8306660144348,
				}, -- [1]
				{
					["y"] = 328.4352563300768,
					["x"] = 562.8308761000344,
				}, -- [2]
				{
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["castbar"] = {
			["fontSize"] = 12,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 1,
				["b"] = 0,
			},
			["positiony"] = -27,
			["enable"] = true,
			["impulsion"] = 1,
			["activeAlpha"] = 1,
			["positionx"] = 9,
			["height"] = 24,
			["borderSize"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 3,
			["fontPathtimer"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["timerAlign"] = "RIGHT",
			["texty"] = 0,
			["timery"] = 0,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["fontSizetimer"] = 16,
			["textx"] = 3,
			["showTimer"] = true,
			["showSpark"] = true,
			["width"] = 192,
			["timerx"] = -3,
			["timerColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
			["showText"] = true,
			["colori"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "LEFT",
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["manabar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -7,
			["width"] = 192,
			["texty"] = 1,
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 1,
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["spells"] = {
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 8921,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Eclat lunaire",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					8921, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "8921",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["abiLast"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_pulsepowerX"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_mode"] = "ADD",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["abiDuration"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_start_height"] = 1,
				["FX_middle_posx"] = 0,
				["names"] = {
					"Eclat lunaire", -- [1]
				},
				["FX_start_alpha"] = 1,
				["strongcheck"] = false,
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_level"] = 10,
				["FX_end_posx"] = 0,
				["FX_middle_alpha"] = 1,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["abiEnd"] = 0,
				["FX_end_scale"] = 1,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["FX_timerenable"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [1]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 60433,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Terre et lune",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					60433, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "60433",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["FX_pulsepowerY"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["perso"] = true,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_pulsepowerX"] = 0,
				["FX_customtexture"] = "",
				["names"] = {
					"Terre et lune", -- [1]
				},
				["FX_start_alpha"] = 1,
				["FX_level"] = 10,
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_rotatespeed"] = 0,
				["FX_timerabove"] = false,
				["combo"] = false,
				["FX_timerposy"] = 0,
				["FX_mode"] = "ADD",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [2]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 93402,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Eclat solaire",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					93402, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "93402",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["FX_pulsepowerY"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["perso"] = true,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_pulsepowerX"] = 0,
				["FX_customtexture"] = "",
				["names"] = {
					"Eclat solaire", -- [1]
				},
				["FX_start_alpha"] = 1,
				["FX_level"] = 10,
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_rotatespeed"] = 0,
				["FX_timerabove"] = false,
				["combo"] = false,
				["FX_timerposy"] = 0,
				["FX_mode"] = "ADD",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [3]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 29166,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					29166, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "29166",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 7586.421,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Innervation",
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["perso"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["showcd"] = true,
				["names"] = {
					"Innervation", -- [1]
				},
				["FX_start_alpha"] = 1,
				["FX_customtexture"] = "",
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["alwaysVisible"] = false,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["height"] = 32,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [4]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16914,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					16914, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "16914",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Ouragan",
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["perso"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["showcd"] = true,
				["names"] = {
					"Ouragan", -- [1]
				},
				["FX_start_alpha"] = 1,
				["FX_customtexture"] = "",
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["alwaysVisible"] = false,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["height"] = 32,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [5]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5570,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					5570, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "5570",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Essaim d'insectes",
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["perso"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["showcd"] = true,
				["names"] = {
					"Essaim d'insectes", -- [1]
				},
				["FX_start_alpha"] = 1,
				["FX_customtexture"] = "",
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["alwaysVisible"] = false,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["height"] = 32,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [6]
			{
				["positiony"] = 0,
				["FX_enable"] = true,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 48518,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 25,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = -32,
				["decimal"] = false,
				["FX_angle"] = 180,
				["FX_height"] = "100",
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = "100",
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 4,
				["ids"] = {
					48518, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "48518",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 3,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Eclipse (lunaire)",
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["perso"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0.6,
				["FX_start_scale"] = 3,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["showcd"] = true,
				["names"] = {
					"Eclipse (lunaire)", -- [1]
				},
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Textures\\SpellActivationOverlays\\Eclipse_Moon",
				["alwaysVisible"] = false,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "ZoomOut",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["height"] = 32,
				["FX_start_posx"] = 20,
				["FX_positiony"] = 80,
			}, -- [7]
			{
				["positiony"] = 0,
				["FX_enable"] = true,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 48517,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 25,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 185,
				["decimal"] = false,
				["FX_angle"] = 180,
				["FX_height"] = "100",
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = "100",
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 4,
				["ids"] = {
					48517, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "48517",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 3,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["abiSpelltext"] = "Eclipse (solaire)",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_mode"] = "BLEND",
				["perso"] = true,
				["abiTimeLeft"] = 200000,
				["height"] = 32,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0.6,
				["FX_start_scale"] = 3,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["FX_customtexture"] = "",
				["names"] = {
					"Eclipse (solaire)", -- [1]
				},
				["FX_start_alpha"] = 0,
				["FX_middle_posy"] = 0,
				["strongcheck"] = false,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["abiDuration"] = 0,
				["FX_texture"] = "Textures\\SpellActivationOverlays\\Eclipse_Sun",
				["FX_end_posx"] = 0,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["abiEnd"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_name"] = "None",
				["FX_pulsepowerY"] = 0,
				["FX_timerabove"] = false,
				["FX_middle_scale"] = 1,
				["FX_start_height"] = 1,
				["FX_rotatespeed"] = -0.05,
				["FX_start_posx"] = 20,
				["FX_positiony"] = 83,
			}, -- [8]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16886,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					16886, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "16886",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 7826.125,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 28.6449999999968,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Grâce de la nature",
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["perso"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["showcd"] = true,
				["names"] = {
					"Grâce de la nature", -- [1]
				},
				["FX_start_alpha"] = 1,
				["FX_customtexture"] = "",
				["abiRipFix"] = 0,
				["FX_end_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["alwaysVisible"] = false,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["height"] = 32,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [9]
		},
		["cursorspeed"] = 30,
		["alert"] = {
			["texture1"] = "Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga",
			["positiony"] = 110.8327939517778,
			["enable"] = true,
			["texture2"] = "Interface\\AddOns\\DroodFocus\\datas\\alertRange.tga",
			["width"] = "48",
			["texture3"] = "Interface\\AddOns\\DroodFocus\\datas\\alertSkull.tga",
			["persistence"] = 7,
			["mode"] = "BLEND",
			["showDebuff"] = true,
			["height"] = "48",
			["level"] = 5,
			["positionx"] = 74.85286888914709,
			["showBuff"] = false,
		},
		["ooc"] = {
			["spell"] = 12536,
			["positiony"] = 17,
			["enable"] = true,
			["scaleMin"] = 1,
			["width"] = "650",
			["textureOff"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
			["height"] = "150",
			["scaleMax"] = 0.1,
			["textureOn"] = "Interface\\AddOns\\DroodFocus\\datas\\ooc.tga",
			["speed"] = 0.1,
			["level"] = 10,
			["positionx"] = 70,
			["mode"] = "ADD",
		},
		["anchor1"] = {
			["visible"] = true,
			["positiony"] = -32,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "UI",
			["positionx"] = 32,
			["height"] = 32,
			["level"] = 1,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor2"] = {
			["visible"] = true,
			["positiony"] = 8.75,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS",
			["mode"] = "BLEND",
			["height"] = 32,
			["positionx"] = 34,
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["eclipsebar"] = {
			["fontSize"] = 12,
			["positiony"] = "57",
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar5.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["textx"] = 0,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				false, -- [8]
			},
			["color"] = {
				["a"] = 1,
				["b"] = 0.6705882352941176,
				["v"] = 0.5254901960784314,
				["r"] = 0.1882352941176471,
			},
			["width"] = "192",
			["color2"] = {
				["a"] = 1,
				["b"] = 0.1058823529411765,
				["v"] = 0.7254901960784314,
				["r"] = 1,
			},
			["positionx"] = "10",
			["showText"] = true,
			["height"] = "22",
			["orientation"] = "HORIZONTAL",
			["texty"] = -0.5,
			["textAlign"] = "CENTER",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["cooldown"] = {
			["offsety"] = -48,
			["positiony"] = -1.000137314198355,
			["enable"] = true,
			["alpha"] = 0.7,
			["width"] = 49,
			["offsetx"] = 0,
			["height"] = 49,
			["positionx"] = 199.9999970197678,
			["level"] = 5,
			["mode"] = "BLEND",
		},
		["healthbar"] = {
			["fontSize"] = 12,
			["positiony"] = 40,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["colorBad"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%) #t",
			["colorAverage"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["colorchg"] = true,
			["textx"] = -7,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["level"] = 2,
			["width"] = 192,
			["positionx"] = 8,
			["height"] = 18,
			["showText"] = true,
			["texty"] = 1,
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "RIGHT",
			["colorGood"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 1,
				["b"] = 0,
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
	},	
	-- FIN [BuildIn] Moonkin
	
	-- DEBUT [BuildIn] TimerBars
	{
		["configversion"] = 420,
		["MiniMapAngle"] = 215.8160744865155,
		["portrait"] = {
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\datas\\empty.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\datas\\bearform.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\datas\\aquaform.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\datas\\catform.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\datas\\travelform.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\datas\\moonkinform.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\datas\\flightform.tga", -- [7]
			},
			["enable"] = false,
			["positionx"] = 1,
			["positiony"] = 1.5,
			["height"] = "48",
			["level"] = 5,
			["mode"] = "ADD",
			["width"] = "48",
		},
		["powerbar"] = {
			["fontSize"] = 15,
			["positiony"] = -18.5,
			["enable"] = true,
			["showSpark"] = true,
			["borderSize"] = 2,
			["colorNrj"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["texty"] = 2,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["interval"] = 1,
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0.5,
				["v"] = 0.5,
				["r"] = 0.5,
			},
			["sformat"] = "#c",
			["textAlign"] = "BOTTOMRIGHT",
			["orientation"] = "HORIZONTAL",
			["colorRage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["textx"] = -4,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
			},
			["enableArrows"] = true,
			["colorMana"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["arrows"] = {
				33876, -- [1]
				5221, -- [2]
				80, -- [3]
				1079, -- [4]
				-1, -- [5]
				-1, -- [6]
			},
			["width"] = 192,
			["showText"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["height"] = "26",
			["positionx"] = 10,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["threatbar"] = {
			["fontSize"] = 8,
			["positiony"] = "-50",
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#c%",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
			},
			["enable"] = false,
			["width"] = 192,
			["textx"] = -4,
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = "10",
			["positionx"] = "10",
			["texty"] = 0,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeX"] = 1,
		["sound"] = {
			["enable"] = true,
			["soundfiles"] = {
				"", -- [1]
				"Sound\\Spells\\Druid_Pounce.wav", -- [2]
				"", -- [3]
				"Sound\\Spells\\Druid_FeralCharge.wav", -- [4]
				"", -- [5]
				"", -- [6]
				"", -- [7]
			},
		},
		["timelines"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["enable"] = false,
			["activeAlpha"] = 0.1,
			["width"] = 1,
		},
		["activeForms"] = {
			false, -- [1]
			true, -- [2]
			false, -- [3]
			true, -- [4]
			false, -- [5]
			false, -- [6]
			false, -- [7]
		},
		["anchor5"] = {
			["visible"] = true,
			["positiony"] = -102,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "INFOS",
			["positionx"] = 18,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor3"] = {
			["visible"] = true,
			["positiony"] = "-44",
			["scale"] = 0.85,
			["width"] = 32,
			["info"] = "TIMERBARS 1",
			["positionx"] = "30",
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["icons"] = {
			["fontSize"] = 13,
			["orderByTime"] = true,
			["decimal"] = false,
			["automatic"] = true,
			["showSpiral"] = 1,
			["inactiveAlpha"] = 0.3,
			["level"] = 10,
			["textsoffsets"] = {
				{
					["visible"] = true,
					["offsety"] = -2,
					["align"] = "TOP",
					["offsetx"] = 0,
					["size"] = 14,
				}, -- [1]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMRIGHT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [2]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMLEFT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["growup"] = false,
			["pointpa"] = true,
			["width"] = 37,
			["activeAlpha"] = 1,
			["speed"] = 4,
			["enable"] = true,
			["pulse"] = 1.6,
			["height"] = 37,
			["colonne"] = 8,
			["mode"] = "BLEND",
			["colonne2"] = 8,
		},
		["blood"] = {
			["persistence"] = 7,
			["level"] = 1,
			["enable"] = true,
			["mode"] = "BLEND",
			["NotInRaid"] = true,
			["size"] = 0.5,
		},
		["anchor4"] = {
			["visible"] = true,
			["positiony"] = "-46",
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 2",
			["positionx"] = "224",
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor7"] = {
			["visible"] = true,
			["positiony"] = 130,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 2",
			["level"] = 1,
			["height"] = 32,
			["positionx"] = -186,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["alignToGrid"] = true,
		["inCombat"] = false,
		["configname"] = "[BuildIn] DF TimerBars",
		["combo"] = {
			["fontSize"] = 18,
			["positiony"] = -20.14594849032091,
			["enable"] = true,
			["textOffsetX"] = 12,
			["impulsion"] = 1.75,
			["level"] = 4,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\combo.tga",
			["angleA"] = 288,
			["offsety"] = 0,
			["ptype"] = 1,
			["angleB"] = 183,
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				true, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
			},
			["mode"] = "BLEND",
			["width"] = 18,
			["offsetx"] = 16,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showText"] = false,
			["textOffsetY"] = -17,
			["height"] = 18,
			["positionx"] = 60.20493056951318,
			["rayon"] = 37,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["anchor0"] = {
			["visible"] = true,
			["positiony"] = 279,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "GLOBAL",
			["positionx"] = 626,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor6"] = {
			["visible"] = true,
			["positiony"] = -13,
			["scale"] = 1,
			["width"] = "32",
			["info"] = "CD",
			["level"] = 10,
			["height"] = "32",
			["positionx"] = -26,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["minimap"] = true,
		["targetbar"] = {
			["fontSize"] = 11,
			["positiony"] = 99,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.75,
				["r"] = 1,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%) #t",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
			},
			["enable"] = false,
			["width"] = 192,
			["textx"] = -4,
			["positionx"] = 18,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = "13",
			["textAlign"] = "RIGHT",
			["texty"] = 0,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["infos"] = {
			["fontSize"] = 8,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["infolines"] = "PA: #meleeAP - Crit: #meleeCrit - Haste: #meleeHaste - Mastery: #mastery",
			["enable"] = false,
			["level"] = 20,
			["backColor"] = {
				["a"] = 0,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["textColor"] = {
				["a"] = 0.4600000381469727,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["uiAlwaysShow"] = false,
		["timerbar"] = {
			["activeAlpha"] = 1,
			["cdColor"] = {
				["a"] = 0.4900000095367432,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0.5,
			["level"] = 4,
			["height2"] = "22",
			["prop2"] = true,
			["growup"] = false,
			["font1Size"] = 12,
			["timeline"] = 14,
			["cdoffsety"] = 2,
			["height"] = "22",
			["activeAlpha2"] = 1,
			["orderByTime"] = true,
			["enable"] = true,
			["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["border"] = true,
			["prop"] = false,
			["borderSize"] = 1,
			["activeAlphaCD"] = 1,
			["cdoffsetx"] = 0,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["textsoffsets"] = {
				{
					["offsety"] = 1,
					["offsetx"] = 0,
				}, -- [1]
				{
					["offsety"] = 0,
					["offsetx"] = 2,
				}, -- [2]
			},
			["activeAlphaCD2"] = 1,
			["stackup2"] = true,
			["width"] = "226",
			["inactiveAlpha2"] = 0,
			["showSpark"] = true,
			["showTimeLine"] = true,
			["width2"] = "260",
			["font2Size"] = 20,
			["stackup1"] = false,
			["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeY"] = 1,
		["gps"] = {
			["fontSize"] = 16,
			["gpsTarget"] = {
				"target", -- [1]
				"focus", -- [2]
			},
			["positiony"] = 202.6987448411231,
			["enable"] = false,
			["offsety"] = -22,
			["alpha"] = 1,
			["width"] = "40",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["positionx"] = 0,
			["level"] = 10,
			["mode"] = "BLEND",
			["height"] = "40",
			["offsetx"] = 0,
			["positions"] = {
				{
					["y"] = 395.5107913354188,
					["x"] = 562.8306660144348,
				}, -- [1]
				{
					["y"] = 328.4352563300768,
					["x"] = 562.8308761000344,
				}, -- [2]
				{
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["castbar"] = {
			["fontSize"] = 12,
			["border"] = true,
			["positiony"] = "4",
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["impulsion"] = 1,
			["activeAlpha"] = 1,
			["textAlign"] = "LEFT",
			["orientation"] = "HORIZONTAL",
			["borderSize"] = 2,
			["colori"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 1,
			["fontPathtimer"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["timerAlign"] = "RIGHT",
			["timerColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["timery"] = 0,
			["timerx"] = -3,
			["width"] = "194",
			["textx"] = 3,
			["showSpark"] = true,
			["showTimer"] = true,
			["fontSizetimer"] = 16,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["texty"] = 0,
			["showText"] = true,
			["enable"] = false,
			["height"] = 24,
			["positionx"] = 9,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["manabar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
			},
			["textx"] = -7,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["positionx"] = 8,
			["showText"] = true,
			["height"] = 18,
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "RIGHT",
			["texty"] = 1,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["spells"] = {
			{
				["positiony"] = 0,
				["FX_enable"] = true,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 50,
				["sType"] = "ComboPoint",
				["positionx"] = 0,
				["FX_positionx"] = 73,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Toucher mortel",
				["FX_end_width"] = 1,
				["FX_width"] = "128",
				["timerbar"] = 0,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					5, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 2.5,
				["FX_end_scale"] = 3,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["perso"] = true,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["height"] = 32,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerposy"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerenable"] = false,
				["FX_pulsepowerZ"] = 0.5,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "ComboPoint",
				["FX_pulsepowerX"] = 0,
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Toucher mortel", -- [1]
				},
				["FX_name"] = "HeartBeat",
				["FX_level"] = 10,
				["FX_middle_posy"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["FX_end_posx"] = 0,
				["alwaysVisible"] = false,
				["FX_middle_width"] = 1,
				["abiFake"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_combo.tga",
				["strongcheck"] = false,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_pulsepowerY"] = 0,
				["FX_start_scale"] = 3,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 27,
			}, -- [1]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 81022,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 74,
				["decimal"] = false,
				["FX_angle"] = 21,
				["FX_height"] = "128",
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 0,
				["FX_width"] = "128",
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 22,
				["ids"] = {
					81022, -- [1]
				},
				["FX_middle_scale"] = 1.1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.65,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "81022",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 0,
				["abiCD"] = 0,
				["abiLastCd"] = 2.769000000000233,
				["FX_chakerpower"] = 1,
				["FX_end_scale"] = 1.1,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["abiSpelltext"] = "Ruée",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_timerposy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["height"] = 32,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1.1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["perso"] = true,
				["FX_pulsepowerY"] = 0,
				["names"] = {
					"Ruée", -- [1]
				},
				["FX_name"] = "FromRight",
				["FX_level"] = 10,
				["FX_middle_posy"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_timeralpha"] = 0.3,
				["alwaysVisible"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["strongcheck"] = false,
				["FX_middle_width"] = 1,
				["abiFake"] = 0,
				["abiEnd"] = 0,
				["FX_end_posx"] = -120,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "tiger",
				["FX_timerabove"] = false,
				["FX_rotatespeed"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiDuration"] = 0,
				["FX_start_posx"] = 120,
				["FX_positiony"] = 209,
			}, -- [2]
			{
				["positiony"] = 0,
				["FX_enable"] = true,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16870,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 73,
				["decimal"] = false,
				["FX_angle"] = 0,
				["FX_height"] = "150",
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = "650",
				["timerbar"] = 2,
				["FX_pulsespeed"] = 18,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					16870, -- [1]
				},
				["FX_middle_scale"] = 1.25,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.9,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "16870",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 1.935000000004948,
				["FX_chakerpower"] = 1,
				["FX_end_scale"] = 2.5,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["abiSpelltext"] = "Idées claires",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_timerposy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["height"] = 32,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 2.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["perso"] = true,
				["FX_pulsepowerY"] = 0,
				["names"] = {
					"Idées claires", -- [1]
				},
				["FX_name"] = "Custom",
				["FX_level"] = 10,
				["FX_middle_posy"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_timeralpha"] = 1,
				["alwaysVisible"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga",
				["strongcheck"] = false,
				["FX_middle_width"] = 1,
				["abiFake"] = 0,
				["abiEnd"] = 0,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0.15,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["FX_rotatespeed"] = 0.5,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 0.6235294117647059,
					["b"] = 1,
				},
				["abiDuration"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 27,
			}, -- [3]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22842,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					22842, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "22842",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Régénération frénétique",
				["perso"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["height"] = 32,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_rotatespeed"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["color"] = {
					["a"] = 1,
					["r"] = 0.02352941176470588,
					["v"] = 0.1215686274509804,
					["b"] = 1,
				},
				["FX_name"] = "Custom",
				["names"] = {
					"Régénération frénétique", -- [1]
				},
				["showcd"] = true,
				["FX_middle_posy"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_customtexture"] = "",
				["FX_timeralpha"] = 0.25,
				["alwaysVisible"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_width"] = 1,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["abiEnd"] = 0,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_level"] = 10,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [4]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 52610,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					52610, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "52610",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 29.77999999999884,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Rugissement sauvage",
				["perso"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["height"] = 32,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_rotatespeed"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.1098039215686275,
				},
				["FX_name"] = "Custom",
				["names"] = {
					"Rugissement sauvage", -- [1]
				},
				["showcd"] = true,
				["FX_middle_posy"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_customtexture"] = "",
				["FX_timeralpha"] = 0.25,
				["alwaysVisible"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_width"] = 1,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["abiEnd"] = 0,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_level"] = 10,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [5]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 61336,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					61336, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "61336",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 0.0392156862745098,
					["v"] = 0.192156862745098,
					["b"] = 1,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["showcd"] = true,
				["abiSpelltext"] = "Instincts de survie",
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_height"] = 1,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["height"] = 32,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_pulsepowerY"] = 0,
				["FX_name"] = "Custom",
				["names"] = {
					"Instincts de survie", -- [1]
				},
				["FX_middle_scale"] = 1,
				["strongcheck"] = false,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_middle_posy"] = 0,
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["alwaysVisible"] = false,
				["FX_middle_width"] = 1,
				["FX_end_posx"] = 0,
				["abiFake"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiDuration"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_level"] = 10,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_middle_posx"] = 0,
				["sType"] = "BuffPlayer",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [6]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 467,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					467, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "467",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Epines",
				["perso"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["height"] = 32,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_rotatespeed"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_name"] = "Custom",
				["names"] = {
					"Epines", -- [1]
				},
				["showcd"] = true,
				["FX_middle_posy"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["FX_customtexture"] = "",
				["FX_timeralpha"] = 0.25,
				["alwaysVisible"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_width"] = 1,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["abiEnd"] = 0,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_level"] = 10,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [7]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5229,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					5229, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "5229",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 0.06274509803921569,
					["v"] = 1,
					["b"] = 0.1450980392156863,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["FX_pulsepowerY"] = 0,
				["perso"] = false,
				["FX_level"] = 10,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["showcd"] = true,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_rotatespeed"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_mode"] = "ADD",
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_middle_posx"] = 0,
				["FX_name"] = "Custom",
				["names"] = {
					"Enrager", -- [1]
				},
				["abiSpelltext"] = "Enrager",
				["FX_middle_posy"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["FX_customtexture"] = "",
				["FX_timeralpha"] = 0.25,
				["alwaysVisible"] = false,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_width"] = 1,
				["strongcheck"] = false,
				["abiFake"] = 0,
				["abiEnd"] = 0,
				["FX_end_posx"] = 0,
				["FX_pulsepower"] = 0,
				["FX_end_posy"] = 0,
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_timerposy"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [8]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 8998,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					8998, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "8998",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["abiSpelltext"] = "Dérobade",
				["perso"] = false,
				["sType"] = "BuffPlayer",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_end_scale"] = 1,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_level"] = 10,
				["FX_start_alpha"] = 1,
				["names"] = {
					"Dérobade", -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["showcd"] = true,
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["FX_middle_alpha"] = 1,
				["FX_middle_width"] = 1,
				["height"] = 32,
				["abiFake"] = 0,
				["FX_end_posx"] = 0,
				["abiRipFix"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.1647058823529412,
					["r"] = 0.01176470588235294,
				},
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [9]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1850,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Célérité",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					1850, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "1850",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0.1176470588235294,
					["v"] = 1,
					["r"] = 0.02745098039215686,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["perso"] = false,
				["FX_pulsepowerX"] = 0,
				["abiDuration"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_level"] = 10,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerposy"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_middle_posx"] = 0,
				["FX_start_alpha"] = 1,
				["names"] = {
					"Célérité", -- [1]
				},
				["FX_rotatespeed"] = 0,
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["showcd"] = true,
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["FX_middle_alpha"] = 1,
				["FX_middle_width"] = 1,
				["sType"] = "BuffPlayer",
				["abiFake"] = 0,
				["height"] = 32,
				["abiRipFix"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_timerenable"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [10]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80964,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Coup de crâne",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					80964, -- [1]
					80965, -- [2]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "80964;80965",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["perso"] = true,
				["FX_pulsepowerX"] = 0,
				["abiDuration"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_level"] = 10,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerposy"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_middle_posx"] = 0,
				["FX_start_alpha"] = 1,
				["names"] = {
					"Coup de crâne", -- [1]
					"Coup de crâne", -- [2]
				},
				["FX_rotatespeed"] = 0,
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["showcd"] = true,
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["FX_middle_alpha"] = 1,
				["FX_middle_width"] = 1,
				["sType"] = "DebuffTarget",
				["abiFake"] = 0,
				["height"] = 32,
				["abiRipFix"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_timerenable"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [11]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 91565,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Feu féerique",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					91565, -- [1]
					7386, -- [2]
					8647, -- [3]
					35387, -- [4]
					50498, -- [5]
					770, -- [6]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "91565;7386;8647;35387;50498;770",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["FX_rotatespeed"] = 0,
				["combo"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_level"] = 10,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_start_alpha"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0.0196078431372549,
					["v"] = 0.6588235294117647,
					["r"] = 1,
				},
				["names"] = {
					"Feu féerique", -- [1]
					"Fracasser armure", -- [2]
					"Exposer l'armure", -- [3]
					"Crachat corrosif", -- [4]
					"Déchirer armure", -- [5]
					"Lucioles", -- [6]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_alpha"] = 1,
				["FX_middle_width"] = 1,
				["sType"] = "DebuffTarget",
				["height"] = 32,
				["abiFake"] = 0,
				["abiRipFix"] = 0,
				["showcd"] = true,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_start_height"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiUpTime"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [12]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33876,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Mutilation",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					33876, -- [1]
					33878, -- [2]
					46857, -- [3]
					50271, -- [4]
					35290, -- [5]
					16511, -- [6]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "33876;33878;46857;50271;35290;16511",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["FX_rotatespeed"] = 0,
				["combo"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_level"] = 10,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_start_alpha"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0.05098039215686274,
					["r"] = 1,
				},
				["names"] = {
					"Mutilation", -- [1]
					"Mutilation", -- [2]
					"Traumatisme", -- [3]
					"Déchirure du tendon", -- [4]
					"Encorner", -- [5]
					"Hémorragie", -- [6]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_alpha"] = 1,
				["FX_middle_width"] = 1,
				["sType"] = "DebuffTarget",
				["height"] = 32,
				["abiFake"] = 0,
				["abiRipFix"] = 0,
				["showcd"] = true,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_start_height"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["abiUpTime"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [13]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1822,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["alwaysVisible"] = false,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Griffure",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					1822, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "1822",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["FX_rotatespeed"] = 0,
				["combo"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_start_scale"] = 1,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_level"] = 10,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_start_alpha"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["names"] = {
					"Griffure", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["FX_end_posx"] = 0,
				["abiEnd"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_middle_alpha"] = 1,
				["FX_middle_width"] = 1,
				["height"] = 32,
				["sType"] = "DebuffTarget",
				["abiFake"] = 0,
				["abiRipFix"] = 0,
				["showcd"] = true,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_start_height"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["abiUpTime"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [14]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33745,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					33745, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "33745",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["abiLast"] = 0,
				["FX_pulsepowerY"] = 0,
				["abiSpelltext"] = "Lacérer",
				["FX_mode"] = "ADD",
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["FX_pulsespeedY"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["combo"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["names"] = {
					"Lacérer", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_end_scale"] = 1,
				["FX_timeralpha"] = 0.25,
				["FX_level"] = 10,
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["abiEnd"] = 0,
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_start_scale"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["FX_customtexture"] = "",
				["FX_timerposy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [15]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1079,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["sType"] = "DebuffTarget",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Déchirure",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					1079, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "1079",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerX"] = 0,
				["height"] = 32,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["abiUpTime"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["combo"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["perso"] = true,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["names"] = {
					"Déchirure", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_end_scale"] = 1,
				["FX_timeralpha"] = 0.25,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["abiEnd"] = 0,
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["showcd"] = true,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_end_posx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = true,
				["FX_customtexture"] = "",
				["abiDuration"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [16]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 99,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Rugissement démoralisant",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					99, -- [1]
					1160, -- [2]
					702, -- [3]
					26016, -- [4]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "99;1160;702;26016",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["FX_mode"] = "ADD",
				["abiUpTime"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_customtexture"] = "",
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["combo"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["names"] = {
					"Rugissement démoralisant", -- [1]
					"Cri démoralisant", -- [2]
					"Malédiction de faiblesse", -- [3]
					"Justification", -- [4]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_middle_posx"] = 0,
				["FX_timeralpha"] = 0.25,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0.4470588235294117,
					["b"] = 0,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["sType"] = "DebuffTarget",
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["abiLast"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_end_scale"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [17]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80951,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Pulvérisation",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 1,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					80951, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "80951",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerX"] = 0,
				["height"] = 32,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["abiUpTime"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["combo"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["perso"] = false,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["names"] = {
					"Pulvérisation", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_end_scale"] = 1,
				["FX_timeralpha"] = 0.25,
				["color"] = {
					["a"] = 1,
					["b"] = 0.1411764705882353,
					["v"] = 1,
					["r"] = 0,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["sType"] = "BuffPlayer",
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["abiLast"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_end_posx"] = 0,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_customtexture"] = "",
				["abiDuration"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [18]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 69369,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["sType"] = "BuffPlayer",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["abiSpelltext"] = "Rapidité du prédateur",
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					69369, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "69369",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 11.16700000000128,
				["FX_chakerpower"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsepowerY"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_customtexture"] = "",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["combo"] = false,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["abiDuration"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["names"] = {
					"Rapidité du prédateur", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_middle_posx"] = 0,
				["FX_timeralpha"] = 0.25,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["height"] = 32,
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["abiLast"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_end_scale"] = 1,
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["abiUpTime"] = 0,
				["abiEnd"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [19]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 50334,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 60,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 139,
				["FX_angle"] = 3,
				["FX_height"] = "128",
				["abiSpelltext"] = "Berserk",
				["FX_end_width"] = 1,
				["FX_width"] = "128",
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 18,
				["ids"] = {
					50334, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.35,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "50334",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 3,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = true,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["FX_mode"] = "BLEND",
				["abiUpTime"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_customtexture"] = "paw",
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["combo"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 2.5,
				["FX_timerenable"] = true,
				["abiUserText"] = "",
				["FX_name"] = "ZoomIn",
				["FX_end_posx"] = 0,
				["names"] = {
					"Berserk", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = true,
				["FX_middle_posx"] = 0,
				["FX_timeralpha"] = 0.35,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0.5411764705882353,
					["b"] = 0,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["sType"] = "BuffPlayer",
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["abiLast"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_scale"] = 3,
				["FX_timerabove"] = false,
				["getUptime"] = false,
				["abiDuration"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 97,
			}, -- [20]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5217,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["abiUptime"] = 0,
				["FX_speed"] = 60,
				["abiEnd"] = 0,
				["positionx"] = 0,
				["FX_positionx"] = 11,
				["FX_angle"] = 0,
				["FX_height"] = "72",
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = "72",
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					5217, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.35,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5217",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 29.31000000000495,
				["FX_chakerpower"] = 1,
				["FX_end_scale"] = 3,
				["FX_timersmall"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsepowerY"] = 3,
				["abiSpelltext"] = "Fureur du tigre",
				["sType"] = "BuffPlayer",
				["FX_pulsespeedY"] = 2.5,
				["FX_end_height"] = 1,
				["abiUpTime"] = 0,
				["perso"] = false,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["combo"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = true,
				["abiUserText"] = "",
				["FX_name"] = "ZoomIn",
				["FX_end_posx"] = 0,
				["names"] = {
					"Fureur du tigre", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_middle_posx"] = 0,
				["FX_timeralpha"] = 0.35,
				["color"] = {
					["a"] = 1,
					["b"] = 0.5764705882352941,
					["v"] = 1,
					["r"] = 0,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["height"] = 32,
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["abiLast"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = false,
				["getUptime"] = false,
				["FX_customtexture"] = "lion",
				["FX_start_scale"] = 2.5,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 97,
			}, -- [21]
			{
				["positiony"] = 0,
				["FX_enable"] = false,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22812,
				["FX_timerposx"] = 0,
				["abiNextTick"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 23,
				["abiUptime"] = 0,
				["FX_speed"] = 30,
				["FX_customtexture"] = "",
				["positionx"] = 0,
				["FX_positionx"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 64,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 64,
				["timerbar"] = 2,
				["FX_pulsespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					22812, -- [1]
				},
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["showaura"] = false,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 1,
				["spellIDs"] = "22812",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_level"] = 10,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_end_scale"] = 1,
				["FX_timersmall"] = false,
				["FX_pulsepowerY"] = 0,
				["FX_timerposy"] = 0,
				["height"] = 32,
				["abiEnd"] = 0,
				["abiUpTime"] = 0,
				["FX_end_height"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "ADD",
				["combo"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["perso"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["names"] = {
					"Ecorce", -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["FX_middle_posx"] = 0,
				["FX_timeralpha"] = 0.25,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.6039215686274509,
				},
				["FX_middle_width"] = 1,
				["alwaysVisible"] = false,
				["sType"] = "BuffPlayer",
				["abiFake"] = 0,
				["FX_rotatespeed"] = 0,
				["abiLast"] = 0,
				["FX_pulsepower"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
				},
				["abiRipFix"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = true,
				["getUptime"] = false,
				["FX_start_scale"] = 1,
				["abiSpelltext"] = "Ecorce",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 0,
			}, -- [22]
		},
		["healthbar"] = {
			["fontSize"] = 12,
			["positiony"] = 40,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["colorBad"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%) #t",
			["colorAverage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.5,
				["r"] = 1,
			},
			["textx"] = -7,
			["colorchg"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
			},
			["colorGood"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["width"] = 192,
			["textAlign"] = "RIGHT",
			["orientation"] = "HORIZONTAL",
			["showText"] = true,
			["texty"] = 1,
			["height"] = 18,
			["positionx"] = 8,
			["level"] = 2,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["cooldown"] = {
			["offsety"] = -48,
			["positiony"] = -1.000137314198355,
			["enable"] = true,
			["alpha"] = 0.7,
			["width"] = 49,
			["mode"] = "BLEND",
			["height"] = 49,
			["offsetx"] = 0,
			["level"] = 5,
			["positionx"] = 199.9999970197678,
		},
		["ooc"] = {
			["spell"] = 12536,
			["positiony"] = 17,
			["enable"] = true,
			["mode"] = "ADD",
			["width"] = "650",
			["textureOff"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
			["positionx"] = 70,
			["scaleMax"] = 0.1,
			["textureOn"] = "Interface\\AddOns\\DroodFocus\\datas\\ooc.tga",
			["speed"] = 0.1,
			["level"] = 10,
			["height"] = "150",
			["scaleMin"] = 1,
		},
		["anchor1"] = {
			["visible"] = true,
			["positiony"] = -8,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "UI",
			["level"] = 1,
			["height"] = 32,
			["positionx"] = 27,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor2"] = {
			["visible"] = true,
			["positiony"] = 292,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS",
			["positionx"] = -154,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["eclipsebar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["textx"] = -7,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
			},
			["texty"] = 1,
			["width"] = 192,
			["color2"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0.5,
				["b"] = 1,
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["alert"] = {
			["texture1"] = "Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga",
			["positiony"] = 80.93645765451873,
			["enable"] = true,
			["texture2"] = "Interface\\AddOns\\DroodFocus\\datas\\alertRange.tga",
			["width"] = "48",
			["showBuff"] = false,
			["persistence"] = 7,
			["level"] = 5,
			["positionx"] = 73.14466287860626,
			["height"] = "48",
			["showDebuff"] = true,
			["mode"] = "BLEND",
			["texture3"] = "Interface\\AddOns\\DroodFocus\\datas\\alertSkull.tga",
		},
		["cursorspeed"] = 30,
	}, -- [2]	
	-- FIN [BuildIn] TimerBars	
}

DF_sharemedia = {
}

DF_talents = {
}

